     1                                  
     2                                  ; Public Domain
     3                                  
     4                                  ; test install command: install; .; history uninstall
     5                                  ; test run command: ; .; .
     6                                  
     7                                  %include "lmacros3.mac"
     1                              <1> [list -]
    14                              <2> [list -]
    14                              <1> [list -]
     8                                  %include "eld.mac"
     1                              <1> %if 0
     2                              <1> 
     3                              <1> Extensions for lDebug macros
     4                              <1> 
     5                              <1> Copyright (C) 2008-2023 E. C. Masloch
     6                              <1> 
     7                              <1> Usage of the works is permitted provided that this
     8                              <1> instrument is retained with the works, so that any entity
     9                              <1> that uses the works is notified of this instrument.
    10                              <1> 
    11                              <1> DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
    12                              <1> 
    13                              <1> %endif
    14                              <1> 
    15                              <1> %ifndef ELD_MAC
    16                              <1> %define ELD_MAC 1
    17                              <1> 
    18                              <1> %include "lmacros3.mac"
     1                              <2> [list -]
    19                              <1> 
    20                              <1> 		; ELD executable header
    21                              <1> 	struc ELD_HEADER
    22 00000000 ????????            <1> eldhSignature:		resb 4	; "ELD1"
    23 00000004 ??????              <1> 			resb 3	; reserved
    24 00000007 ??                  <1> 			resb 1	; 26 (Ctrl-Z)
    25 00000008 ????????            <1> eldhCodeOffset:		resd 1	; position displacement from eldhSignature
    26 0000000C ????                <1> eldhCodeImageLength:	resw 1	; amount bytes, at least 32
    27 0000000E ????                <1> eldhCodeAllocLength:	resw 1	; amount bytes, added to prior. sum < 64 KiB
    28 00000010 ????????            <1> eldhDataOffset:		resd 1
    29 00000014 ????                <1> eldhDataImageLength:	resw 1	; (zero allowed)
    30 00000016 ????                <1> eldhDataAllocLength:	resw 1	; (zero allowed)
    31 00000018 ????                <1> eldhCodeEntrypoint:	resw 1	; within code section, used as displacement
    32 0000001A ????????            <1> eldhReserved:		resb 4	; reserved
    33 0000001E ????                <1> eldhExtensionSize:	resw 1	; from eldhSignature, -> past eldhx fields in use
    34                              <1> 	endstruc
    35                              <1> 	endarea ELD_HEADER, 1
    36                              <1> 
    37                              <1> 	struc ELD_HEADERX
    38 00000000 <res 20h>           <1> eldhxHeader:		resb ELD_HEADER_size
    39 00000020 ????????            <1> eldhxDescriptionOffset:	resd 1	; zero if none, from eldhxHeader. <= 128 Bytes
    40 00000024 ????????            <1> eldhxHelpOffset:	resd 1	; zero if none, from eldhxHeader
    41 00000028 ????????            <1> eldhxLibTable:		resd 1	; zero if none, from eldhxHeader
    42 0000002C ????????            <1> eldhxDateTimeOffset:	resd 1	; zero if none, from eldhxHeader
    43                              <1> 	alignb 16
    44                              <1> 	endstruc
    45                              <1> 
    46                              <1> 	struc ELD_TRAILER_HEADER
    47 00000000 ????????????????    <1> eldthSignature:		resb 8	; "ELD1TAIL"
    48 00000008 ????????            <1> eldthHeaderOffset:	resd 1	; negative displacement from eldthSignature,
    49                              <1> 				;  add this dword to the seek offset
    50 0000000C ????                <1> eldthReserved:		resw 1	; reserved, must be initialised to zero
    51 0000000E ????                <1> eldthChecksum:		resw 1	; sum of all words in trailer header = 0
    52                              <1> 	endstruc
    53                              <1> 	endarea ELD_TRAILER_HEADER, 1
    54                              <1> 
    55                              <1> 	struc ELD_LIBTABLE
    56 00000000 ????                <1> eldltFormat:		resw 1	; current: 0 = uncompressed, 2 = compressed
    57 00000002 ????                <1> eldltAmount:		resw 1
    58 00000004 ????????            <1> eldltOffset:		resd 1	; from eldhxHeader
    59                              <1> eldltCompressedLength:		; (dword, only present if format 2)
    60                              <1> 	endstruc
    61                              <1> 	endarea ELD_LIBTABLE, 1
    62                              <1> 
    63                              <1> 		; ELD instance header
    64                              <1> 	struc ELD_INSTANCE
    65 00000000 ????                <1> eldiStartCode:		resw 1	; -> this structure itself (para aligned)
    66 00000002 ????                <1> eldiEndCode:		resw 1	; -> behind memory used by instance (para aligned)
    67 00000004 ????                <1> eldiStartData:		resw 1	; -> data in data entry section (para aligned), or 0
    68 00000006 ????                <1> eldiEndData:		resw 1	; -> behind data (para aligned), or 0
    69 00000008 ????????????????    <1> eldiIdentifier:		resb 8	; blank-filled text
    70 00000010 ????                <1> eldiFlags:		resw 1	; flags
    71                              <1> eldiListing_size equ 14
    72 00000012 <res Eh>            <1> eldiListing:		resb eldiListing_size
    73                              <1> 				; ASCIZ listing file name
    74                              <1> 	endstruc
    75                              <1> 		; flags for eldiFlags:
    76                              <1> eldifResident:		equ 1
    77                              <1> 
    78                              <1> 		; ELD link info header
    79                              <1> 	struc ELD_LINKINFO
    80 00000000 ????                <1> eldlSignature:		resw 1	; 0E1D1h
    81 00000002 ????????            <1> eldlReserved:		resw 2
    82 00000006 ????                <1> eldlUseLinkHash:	resw 1
    83 00000008 ????                <1> eldlDataAmount:		resw 1
    84 0000000A ????                <1> eldlDataPrefixes:	resw 1
    85 0000000C ????                <1> eldlDataEntries:	resw 1
    86 0000000E ????                <1> eldlDataAddresses:	resw 1
    87 00000010 ????                <1> eldlCodeAmount:		resw 1
    88 00000012 ????                <1> eldlCodePrefixes:	resw 1
    89 00000014 ????                <1> eldlCodeEntries:	resw 1
    90 00000016 ????                <1> eldlCodeAddresses:	resw 1
    91                              <1> 	endstruc
    92                              <1> 
    93                              <1> 	numdef ELD_CODE_VSTART, 9001h
    94                              <1> 	numdef ELD_DATA_VSTART, 8000h
    95                              <1> 	numdef ELD_RELOC_VSTART, 8000h
    96                              <1> 
    97                              <1> 	numdef ELD_RECLAIM_HINT, 0
    98                              <1> 	strdef ELD_LISTING, ""
    99                              <1> 	numdef ELD_DATETIME, 0
   100                              <1> 
   101                              <1> %if _ELD_DATETIME
   102                              <1>  %define PUT_ELDHX_DATETIME_OFFSET at eldhxDateTimeOffset, dd DATAOFFSET + datetime - datastart
   103                              <1>  %macro PUT_ELD_DATETIME 0.nolist
   104                              <1> datetime:	asciz __UTC_DATE__,'T',__UTC_TIME__,'Z'
   105                              <1> 		asciz		; for future extension
   106                              <1>  %endmacro
   107                              <1> %else
   108                              <1>  %define PUT_ELDHX_DATETIME_OFFSET
   109                              <1>  %define PUT_ELD_DATETIME
   110                              <1> %endif
   111                              <1> 
   112                              <1> %endif
     9                                  %include "eldcall.mac"
     1                              <1> %if 0
     2                              <1> 
     3                              <1> Extensions for lDebug call macros
     4                              <1> 
     5                              <1> Copyright (C) 2008-2024 E. C. Masloch
     6                              <1> 
     7                              <1> Usage of the works is permitted provided that this
     8                              <1> instrument is retained with the works, so that any entity
     9                              <1> that uses the works is notified of this instrument.
    10                              <1> 
    11                              <1> DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
    12                              <1> 
    13                              <1> %endif
    14                              <1> 
    15                              <1> %ifndef ELDCALL_MAC
    16                              <1> %define ELDCALL_MAC 1
    17                              <1> 
    18                              <1> %include "lmacros3.mac"
     1                              <2> [list -]
    19                              <1> %include "nasmhash.mac"
     1                              <2> 
     2                              <2> %if 0
     3                              <2> 
     4                              <2> Hashing macros
     5                              <2>  by E. C. Masloch, 2019
     6                              <2> 
     7                              <2> Usage of the works is permitted provided that this
     8                              <2> instrument is retained with the works, so that any entity
     9                              <2> that uses the works is notified of this instrument.
    10                              <2> 
    11                              <2> DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
    12                              <2> 
    13                              <2> %endif
    14                              <2> 
    15                              <2> %ifndef __NASMHASH_MAC__
    16                              <2> %assign __NASMHASH_MAC__ 1
    17                              <2> 
    18                              <2> 
    19                              <2> 	%macro hashdef 2+.nolist
    20                              <2> %ifempty %2
    21                              <2>  %assign _%1 1
    22                              <2> %else
    23                              <2> %ifstr %2
    24                              <2>  %define %%string %2
    25                              <2> %elifid %2
    26                              <2>  %defstr %%string %2
    27                              <2> %elifnum %2
    28                              <2>  %defstr %%string %2
    29                              <2> %eliftok %2
    30                              <2>  %defstr %%string %2
    31                              <2> %else
    32                              <2>  %error Unknown input
    33                              <2> %endif
    34                              <2> %strlen %%length %%string
    35                              <2> %assign %%hash 1
    36                              <2> %assign %%index 1
    37                              <2> %rep %%length
    38                              <2>  %substr %%char %%string %%index
    39                              <2>  %assign %%hash (%%hash * 31 + %%char) & 0FFFFh
    40                              <2>  %assign %%index %%index + 1
    41                              <2> %endrep
    42                              <2> %assign _%1 %%hash
    43                              <2> %endif
    44                              <2> 	%endmacro
    45                              <2> 
    46                              <2> 
    47                              <2> %endif
    20                              <1> %include "elddata.mac"
     1                              <2> %if 0
     2                              <2> 
     3                              <2> Extensions for lDebug data relocation macros
     4                              <2> 
     5                              <2> Copyright (C) 2008-2024 E. C. Masloch
     6                              <2> 
     7                              <2> Usage of the works is permitted provided that this
     8                              <2> instrument is retained with the works, so that any entity
     9                              <2> that uses the works is notified of this instrument.
    10                              <2> 
    11                              <2> DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
    12                              <2> 
    13                              <2> %endif
    14                              <2> 
    15                              <2> %ifndef ELDDATA_MAC
    16                              <2> %define ELDDATA_MAC 1
    17                              <2> 
    18                              <2> %include "lmacros3.mac"
     1                              <3> [list -]
    19                              <2> %include "nasmhash.mac"
     1                              <3> 
     2                              <3> %if 0
     3                              <3> 
     4                              <3> Hashing macros
     5                              <3>  by E. C. Masloch, 2019
     6                              <3> 
     7                              <3> Usage of the works is permitted provided that this
     8                              <3> instrument is retained with the works, so that any entity
     9                              <3> that uses the works is notified of this instrument.
    10                              <3> 
    11                              <3> DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
    12                              <3> 
    13                              <3> %endif
    14                              <3> 
    15                              <3> %ifndef __NASMHASH_MAC__
    16                              <3> %assign __NASMHASH_MAC__ 1
    17                              <3> 
    18                              <3> 
    19                              <3> 	%macro hashdef 2+.nolist
    20                              <3> %ifempty %2
    21                              <3>  %assign _%1 1
    22                              <3> %else
    23                              <3> %ifstr %2
    24                              <3>  %define %%string %2
    25                              <3> %elifid %2
    26                              <3>  %defstr %%string %2
    27                              <3> %elifnum %2
    28                              <3>  %defstr %%string %2
    29                              <3> %eliftok %2
    30                              <3>  %defstr %%string %2
    31                              <3> %else
    32                              <3>  %error Unknown input
    33                              <3> %endif
    34                              <3> %strlen %%length %%string
    35                              <3> %assign %%hash 1
    36                              <3> %assign %%index 1
    37                              <3> %rep %%length
    38                              <3>  %substr %%char %%string %%index
    39                              <3>  %assign %%hash (%%hash * 31 + %%char) & 0FFFFh
    40                              <3>  %assign %%index %%index + 1
    41                              <3> %endrep
    42                              <3> %assign _%1 %%hash
    43                              <3> %endif
    44                              <3> 	%endmacro
    45                              <3> 
    46                              <3> 
    47                              <3> %endif
    20                              <2> %include "eldcheck.mac"
     1                              <3> %if 0
     2                              <3> 
     3                              <3> Extensions for lDebug relocation check macros
     4                              <3> 
     5                              <3> Copyright (C) 2008-2023 E. C. Masloch
     6                              <3> 
     7                              <3> Usage of the works is permitted provided that this
     8                              <3> instrument is retained with the works, so that any entity
     9                              <3> that uses the works is notified of this instrument.
    10                              <3> 
    11                              <3> DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
    12                              <3> 
    13                              <3> %endif
    14                              <3> 
    15                              <3> %ifndef ELDCHECK_MAC
    16                              <3> %define ELDCHECK_MAC 1
    17                              <3> 
    18                              <3> %assign ELDSTRICT 0
    19                              <3> %assign ELDSTRICTCOUNTER 0
    20                              <3> 
    21                              <3> 	%imacro eldstrict 1.nolist
    22                              <3> %ifidni %1, on
    23                              <3>  %assign ELDSTRICT 1
    24                              <3>  [warning +error=reloc-abs]
    25                              <3>  [warning +reloc-abs]
    26                              <3> %elifidni %1, off
    27                              <3>  %assign ELDSTRICT 0
    28                              <3>  [warning -reloc-abs]
    29                              <3> %else
    30                              <3>  %error Unknown keyword
    31                              <3> %endif
    32                              <3> 	%endmacro
    33                              <3> 
    34                              <3> 	%imacro reloc 1+.nolist
    35                              <3> %if ELDSTRICT
    36                              <3>  %if ELDSTRICTCOUNTER
    37                              <3>   %error Missing relocation
    38                              <3>  %endif
    39                              <3>  [warning -reloc-abs]
    40                              <3>  %assign ELDSTRICTCOUNTER 1
    41                              <3> %endif
    42                              <3> %1
    43                              <3> 	%endmacro
    44                              <3> 
    45                              <3> 	%imacro reloc2 1+.nolist
    46                              <3> %if ELDSTRICT
    47                              <3>  %if ELDSTRICTCOUNTER
    48                              <3>   %error Missing relocation
    49                              <3>  %endif
    50                              <3>  [warning -reloc-abs]
    51                              <3>  %assign ELDSTRICTCOUNTER 2
    52                              <3> %endif
    53                              <3> %1
    54                              <3> 	%endmacro
    55                              <3> 
    56                              <3> 	%imacro eldstrictcheck 0.nolist
    57                              <3> %if ELDSTRICT
    58                              <3>  %ifn ELDSTRICTCOUNTER
    59                              <3>   %error Unexpected relocation
    60                              <3>  %else
    61                              <3>   %assign ELDSTRICTCOUNTER ELDSTRICTCOUNTER - 1
    62                              <3>   %ifn ELDSTRICTCOUNTER
    63                              <3>    [warning +reloc-abs]
    64                              <3>   %endif
    65                              <3>  %endif
    66                              <3> %endif
    67                              <3> 	%endmacro
    68                              <3> 
    69                              <3> %endif
    70                              <3> 
    21                              <2> 
    22                              <2> 
    23                              <2> %assign ELDLINKER 0
    24                              <2> 
    25                              <2> %define INTERNAL_CODE_TO_CODE_RELOCATIONS ""
    26                              <2> %define INTERNAL_CODE_TO_DATA_RELOCATIONS ""
    27                              <2> %define INTERNAL_DATA_TO_CODE_RELOCATIONS ""
    28                              <2> %define INTERNAL_DATA_TO_DATA_RELOCATIONS ""
    29                              <2> %define INTERNAL_LINKER_CODE_TO_CODE_RELOCATIONS ""
    30                              <2> %define INTERNAL_LINKER_CODE_TO_DATA_RELOCATIONS ""
    31                              <2> %define INTERNAL_LINKER_DATA_TO_CODE_RELOCATIONS ""
    32                              <2> %define INTERNAL_LINKER_DATA_TO_DATA_RELOCATIONS ""
    33                              <2> %assign ELDDATA_OPTIONAL_STATUS 0		; not any seen yet
    34                              <2> %assign ELDDATA_PMREQUIRED_STATUS 0		; not any seen yet
    35                              <2> 
    36                              <2> 	%imacro internalcoderelocation 0-1.nolist -2
    37                              <2> %assign %%entry $ + _CURRENT_SECTION %+ FIXUP + %1
    38                              <2> %if ELDLINKER
    39                              <2>  %ifidni _CURRENT_SECTION_TYPE, DATA
    40                              <2>   %xdefine INTERNAL_LINKER_DATA_TO_CODE_RELOCATIONS INTERNAL_LINKER_DATA_TO_CODE_RELOCATIONS, %%entry
    41                              <2>  %else
    42                              <2>   %xdefine INTERNAL_LINKER_CODE_TO_CODE_RELOCATIONS INTERNAL_LINKER_CODE_TO_CODE_RELOCATIONS, %%entry
    43                              <2>  %endif
    44                              <2> %else
    45                              <2>  %ifidni _CURRENT_SECTION_TYPE, DATA
    46                              <2>   %xdefine INTERNAL_DATA_TO_CODE_RELOCATIONS INTERNAL_DATA_TO_CODE_RELOCATIONS, %%entry
    47                              <2>  %else
    48                              <2>   %xdefine INTERNAL_CODE_TO_CODE_RELOCATIONS INTERNAL_CODE_TO_CODE_RELOCATIONS, %%entry
    49                              <2>  %endif
    50                              <2> %endif
    51                              <2> 	eldstrictcheck
    52                              <2> 	%endmacro
    53                              <2> 
    54                              <2> 	%imacro internaldatarelocation 0-1.nolist -2
    55                              <2> %assign %%entry $ + _CURRENT_SECTION %+ FIXUP + %1
    56                              <2> %if ELDLINKER
    57                              <2>  %ifidni _CURRENT_SECTION_TYPE, DATA
    58                              <2>   %xdefine INTERNAL_LINKER_DATA_TO_DATA_RELOCATIONS INTERNAL_LINKER_DATA_TO_DATA_RELOCATIONS, %%entry
    59                              <2>  %else
    60                              <2>   %xdefine INTERNAL_LINKER_CODE_TO_DATA_RELOCATIONS INTERNAL_LINKER_CODE_TO_DATA_RELOCATIONS, %%entry
    61                              <2>  %endif
    62                              <2> %else
    63                              <2>  %ifidni _CURRENT_SECTION_TYPE, DATA
    64                              <2>   %xdefine INTERNAL_DATA_TO_DATA_RELOCATIONS INTERNAL_DATA_TO_DATA_RELOCATIONS, %%entry
    65                              <2>  %else
    66                              <2>   %xdefine INTERNAL_CODE_TO_DATA_RELOCATIONS INTERNAL_CODE_TO_DATA_RELOCATIONS, %%entry
    67                              <2>  %endif
    68                              <2> %endif
    69                              <2> 	eldstrictcheck
    70                              <2> 	%endmacro
    71                              <2> 
    72                              <2> ; dw INTERNAL_LINKER_CODE_TO_CODE_RELOCATIONS, 0
    73                              <2> ; dw INTERNAL_LINKER_CODE_TO_DATA_RELOCATIONS, 0
    74                              <2> ; dw INTERNAL_LINKER_DATA_TO_CODE_RELOCATIONS, -1
    75                              <2> ; dw INTERNAL_LINKER_DATA_TO_DATA_RELOCATIONS, -1
    76                              <2> ; dw INTERNAL_CODE_TO_CODE_RELOCATIONS, 0
    77                              <2> ; dw INTERNAL_CODE_TO_DATA_RELOCATIONS, 0
    78                              <2> ; dw INTERNAL_DATA_TO_CODE_RELOCATIONS, -1
    79                              <2> ; dw INTERNAL_DATA_TO_DATA_RELOCATIONS, -1
    80                              <2> 
    81                              <2> 
    82                              <2> %define LINK_DATA_RELOCATIONS ""
    83                              <2> %define LINK_LINKER_DATA_RELOCATIONS ""
    84                              <2> %define LINK_DATA_NAMES db ""
    85                              <2> %define LINK_DATA_DETECTION none, none
    86                              <2> 
    87                              <2> %define LINK_OTHER_DATA_RELOCATIONS ""
    88                              <2> %define LINK_OTHER_LINKER_DATA_RELOCATIONS ""
    89                              <2> %define LINK_OTHER_DATA_NAMES db ""
    90                              <2> %define LINK_OTHER_DATA_DETECTION none, none
    91                              <2> 
    92                              <2> %ifndef ELDOTHER
    93                              <2>  %assign ELDOTHER 0
    94                              <2> %endif
    95                              <2> %assign ELDOTHERLINK 0
    96                              <2> 
    97                              <2> 	%imacro otherlinkdatarelocation 1-3.nolist -2, required
    98                              <2> %if ELDOTHER
    99                              <2>  %assign ELDOTHERLINK 1
   100                              <2> %endif
   101                              <2> 	linkdatarelocation %1, %2, %3
   102                              <2> %assign ELDOTHERLINK 0
   103                              <2> 	%endmacro
   104                              <2> 
   105                              <2> 	%imacro linkdatarelocation 1-3.nolist -2, required
   106                              <2> %assign %%entry $ + _CURRENT_SECTION %+ FIXUP + %2
   107                              <2> %ifidni %3, required
   108                              <2>  %assign %%optional 0
   109                              <2> %elifidni %3, optional
   110                              <2>  %assign %%optional 100h
   111                              <2>  %if ELDDATA_OPTIONAL_STATUS == 0
   112                              <2>   %assign ELDDATA_OPTIONAL_STATUS 1
   113                              <2>  %elif ELDDATA_OPTIONAL_STATUS == 1
   114                              <2>  %else
   115                              <2>   %error Optional data link not allowed here
   116                              <2>  %endif
   117                              <2> %elifidni %3, PM required
   118                              <2>  %assign %%optional 300h
   119                              <2>  %assign ELDDATA_PMREQUIRED_STATUS 1
   120                              <2>  %if ELDDATA_OPTIONAL_STATUS == 0
   121                              <2>   %assign ELDDATA_OPTIONAL_STATUS 1
   122                              <2>  %elif ELDDATA_OPTIONAL_STATUS == 1
   123                              <2>  %else
   124                              <2>   %error Optional data link not allowed here
   125                              <2>  %endif
   126                              <2> %else
   127                              <2>  %fatal Unknown optional keyword
   128                              <2> %endif
   129                              <2> %ifidni _CURRENT_SECTION_TYPE, DATA
   130                              <2>  %assign %%DATASECTION 1
   131                              <2> %else
   132                              <2>  %assign %%DATASECTION 0
   133                              <2> %endif
   134                              <2> 	%if ELDOTHERLINK
   135                              <2> %if ELDLINKER
   136                              <2>  %xdefine LINK_OTHER_LINKER_DATA_RELOCATIONS LINK_OTHER_LINKER_DATA_RELOCATIONS, 1 + %%DATASECTION + %%optional, %%entry, %%name
   137                              <2> %else
   138                              <2>  %xdefine LINK_OTHER_DATA_RELOCATIONS LINK_OTHER_DATA_RELOCATIONS, 1 + %%DATASECTION + %%optional, %%entry, %%name
   139                              <2> %endif
   140                              <2> 	%else
   141                              <2> %if ELDLINKER
   142                              <2>  %xdefine LINK_LINKER_DATA_RELOCATIONS LINK_LINKER_DATA_RELOCATIONS, 1 + %%DATASECTION + %%optional, %%entry, %%name
   143                              <2> %else
   144                              <2>  %xdefine LINK_DATA_RELOCATIONS LINK_DATA_RELOCATIONS, 1 + %%DATASECTION + %%optional, %%entry, %%name
   145                              <2> %endif
   146                              <2> 	%endif
   147                              <2> %defstr %%string %1
   148                              <2> %strlen %%length %%string
   149                              <2> %if %%length > 64
   150                              <2>  %error Too long link name: %1
   151                              <2> %endif
   152                              <2> %define LINK_DATA_CHECK %1
   153                              <2> 	%if ELDOTHERLINK
   154                              <2> 	linkdata_detect LINK_OTHER_DATA_DETECTION
   155                              <2> %if LINK_DATA_NEW
   156                              <2>  %xdefine LINK_OTHER_DATA_DETECTION LINK_OTHER_DATA_DETECTION, %1, %%name
   157                              <2> 	hashdef HASH, %%string
   158                              <2>  %xdefine LINK_OTHER_DATA_NAMES 	LINK_OTHER_DATA_NAMES, %%name:, dw _HASH, {counted %%string}
   160                              <2> %else
   161                              <2>  %%name equ LINK_DATA_DUPLICATE
   162                              <2> %endif
   163                              <2> 	%else
   164                              <2> 	linkdata_detect LINK_DATA_DETECTION
   165                              <2> %if LINK_DATA_NEW
   166                              <2>  %xdefine LINK_DATA_DETECTION LINK_DATA_DETECTION, %1, %%name
   167                              <2> 	hashdef HASH, %%string
   168                              <2>  %xdefine LINK_DATA_NAMES 	LINK_DATA_NAMES, %%name:, dw _HASH, {counted %%string}
   170                              <2> %else
   171                              <2>  %%name equ LINK_DATA_DUPLICATE
   172                              <2> %endif
   173                              <2> 	%endif
   174                              <2> 	eldstrictcheck
   175                              <2> 	%endmacro
   176                              <2> 
   177                              <2> 	%imacro linkdata_detect 2-*.nolist
   178                              <2> %assign LINK_DATA_NEW 1
   179                              <2> %rep (%0 - 2) / 2
   180                              <2>  %rotate 2
   181                              <2>  %ifidni %1, LINK_DATA_CHECK
   182                              <2>   %assign LINK_DATA_NEW 0
   183                              <2>   %xdefine LINK_DATA_DUPLICATE %2
   184                              <2>   %exitrep
   185                              <2>  %endif
   186                              <2> %endrep
   187                              <2> 	%endmacro
   188                              <2> 
   189                              <2> 	%imacro link_data_dump_names 1-*.nolist
   190                              <2> %rep %0
   191                              <2> 	%1
   192                              <2>  %rotate 1
   193                              <2> %endrep
   194                              <2> 	%endmacro
   195                              <2> 
   196                              <2> ; dw LINK_LINKER_DATA_RELOCATIONS, 0, 0
   197                              <2> ; dw LINK_DATA_RELOCATIONS, 0, 0
   198                              <2> ; link_data_dump_names ELDCALL_CODE_NAMES
   199                              <2> 
   200                              <2> %endif
    21                              <1> 
    22                              <1> %assign ELDLINKER 0
    23                              <1> 
    24                              <1> [section relocatedzero nobits vstart=0]
    25                              <1> relocatedzero:
    26                              <1> __SECT__
    27                              <1> 
    28                              <1> 	numdef HOUDINI, 1
    29                              <1> 	numdef HOUDINI_CONDITIONAL, 1
    30                              <1> 
    31                              <1> %imacro houdini 0.nolist
    32                              <1> %if _HOUDINI
    33                              <1>  %if _HOUDINI_CONDITIONAL
    34                              <1> reloc	testopt [ss:relocateddata], 100h
    35                              <1> linkdatarelocation options7, -3
    36                              <1> 	jz %%skip
    37                              <1>  %endif
    38                              <1> reloc	testopt [ss:relocateddata], 100h
    39                              <1> linkdatarelocation internalflags6, -3
    40                              <1> 	jz %%skip
    41                              <1> 	int3
    42                              <1> %%skip:
    43                              <1> %endif
    44                              <1> %endmacro
    45                              <1> 
    46                              <1> %define ELDCALL_CODE_RELOCATIONS ""
    47                              <1> %define ELDCALL_LINKER_CODE_RELOCATIONS ""
    48                              <1> %define ELDCALL_CODE_RELOCATIONS_OPTIONAL ""
    49                              <1> %define ELDCALL_LINKER_CODE_RELOCATIONS_OPTIONAL ""
    50                              <1> %define ELDCALL_CODE_NAMES db ""
    51                              <1> %define ELDCALL_CODE_DETECTION none, none
    52                              <1> %assign ELDCALL_OPTIONAL_STATUS 0		; not any seen yet
    53                              <1> %assign ELDCALL_PMREQUIRED_STATUS 0		; not any seen yet
    54                              <1> 
    55                              <1> 	%imacro extcall 1-2.nolist required
    56                              <1> %ifidni _CURRENT_SECTION_TYPE, DATA
    57                              <1>  %error "ELD call cannot be used in ELD data block"
    58                              <1> %endif
    59                              <1> %assign %%entry $ + _CURRENT_SECTION %+ FIXUP
    60                              <1> %ifidni %2, required
    61                              <1>  %assign %%optional 0
    62                              <1> %elifidni %2, optional
    63                              <1>  %assign %%optional 100h
    64                              <1>  %if ELDCALL_OPTIONAL_STATUS == 0
    65                              <1>   %assign ELDCALL_OPTIONAL_STATUS 1
    66                              <1>  %elif ELDCALL_OPTIONAL_STATUS == 1
    67                              <1>  %else
    68                              <1>   %error Optional code link not allowed here
    69                              <1>  %endif
    70                              <1> %elifidni %2, PM required
    71                              <1>  %assign %%optional 300h
    72                              <1>  %assign ELDCALL_PMREQUIRED_STATUS 1
    73                              <1>  %if ELDCALL_OPTIONAL_STATUS == 0
    74                              <1>   %assign ELDCALL_OPTIONAL_STATUS 1
    75                              <1>  %elif ELDCALL_OPTIONAL_STATUS == 1
    76                              <1>  %else
    77                              <1>   %error Optional code link not allowed here
    78                              <1>  %endif
    79                              <1> %else
    80                              <1>  %fatal Unknown optional keyword
    81                              <1> %endif
    82                              <1> %if 0
    83                              <1> [warning -reloc-rel-word]
    84                              <1> 	call near relocatedzero
    85                              <1> [warning +reloc-rel-word]
    86                              <1> %else
    87                              <1> 	db 0E8h
    88                              <1> reloc	dw relocatedzero
    89                              <1> 	eldstrictcheck
    90                              <1> %endif
    91                              <1> 	jmp strict short %%skipparameter
    92                              <1> 	dw 0
    93                              <1> %%skipparameter:
    94                              <1> %if ELDLINKER
    95                              <1>  %xdefine ELDCALL_LINKER_CODE_RELOCATIONS ELDCALL_LINKER_CODE_RELOCATIONS, %%entry, %%name
    96                              <1>  %xdefine ELDCALL_LINKER_CODE_RELOCATIONS_OPTIONAL ELDCALL_LINKER_CODE_RELOCATIONS_OPTIONAL, 1 + %%optional, %%entry, %%name
    97                              <1> %else
    98                              <1>  %xdefine ELDCALL_CODE_RELOCATIONS ELDCALL_CODE_RELOCATIONS, %%entry, %%name
    99                              <1>  %xdefine ELDCALL_CODE_RELOCATIONS_OPTIONAL ELDCALL_CODE_RELOCATIONS_OPTIONAL, 1 + %%optional, %%entry, %%name
   100                              <1> %endif
   101                              <1> %defstr %%string %1
   102                              <1> %strlen %%length %%string
   103                              <1> %if %%length > 64
   104                              <1>  %error Too long link name: %1
   105                              <1> %endif
   106                              <1> %define ELDCALL_CODE_CHECK %1
   107                              <1> 	linkcode_detect ELDCALL_CODE_DETECTION
   108                              <1> %if ELDCALL_CODE_NEW
   109                              <1>  %xdefine ELDCALL_CODE_DETECTION ELDCALL_CODE_DETECTION, %1, %%name
   110                              <1> 	hashdef HASH, %%string
   111                              <1> %xdefine ELDCALL_CODE_NAMES 	ELDCALL_CODE_NAMES, %%name:, dw _HASH, {counted %%string}
   113                              <1> %else
   114                              <1>  %%name equ ELDCALL_CODE_DUPLICATE
   115                              <1> %endif
   116                              <1> 	%endmacro
   117                              <1> 
   118                              <1> 	%imacro linkcode_detect 2-*.nolist
   119                              <1> %assign ELDCALL_CODE_NEW 1
   120                              <1> %rep (%0 - 2) / 2
   121                              <1>  %rotate 2
   122                              <1>  %ifidni %1, ELDCALL_CODE_CHECK
   123                              <1>   %assign ELDCALL_CODE_NEW 0
   124                              <1>   %xdefine ELDCALL_CODE_DUPLICATE %2
   125                              <1>   %exitrep
   126                              <1>  %endif
   127                              <1> %endrep
   128                              <1> 	%endmacro
   129                              <1> 
   130                              <1> 
   131                              <1> %define ELDCALL_CALLCALL_LIST none
   132                              <1> 
   133                              <1> 	%imacro extcallcall 1.nolist
   134                              <1> 	call %1
   135                              <1> %xdefine ELDCALL_CALLCALL_LIST ELDCALL_CALLCALL_LIST, %1
   136                              <1> 	%endmacro
   137                              <1> 
   138                              <1> %assign ELDCALLCALL_DUMPED 0
   139                              <1> 
   140                              <1> 	%imacro eldcall_dump_callcall 1-*.nolist
   141                              <1> %define ELDCALL_CALLCALL_PROCESSED none
   142                              <1>  %rep %0 - 1
   143                              <1>   %rotate 1
   144                              <1>   %define ELDCALL_CHECK %1
   145                              <1> 	eldcall_callcall_detect ELDCALL_CALLCALL_PROCESSED
   146                              <1>   %if ELDCALL_NEW
   147                              <1>    %xdefine ELDCALL_CALLCALL_PROCESSED ELDCALL_CALLCALL_PROCESSED, %1
   148                              <1> 	align 8, nop
   149                              <1> %1:
   150                              <1> 	extcall %1
   151                              <1> 	retn
   152                              <1>   %endif
   153                              <1>  %endrep
   154                              <1> %unimacro extcallcall 1.nolist
   155                              <1> %assign ELDCALLCALL_DUMPED 1
   156                              <1> %define ELDCALL_CALLCALL_LIST none
   157                              <1> 	%endmacro
   158                              <1> 
   159                              <1> 	%imacro eldcall_callcall_detect 1-*.nolist
   160                              <1> %assign ELDCALL_NEW 1
   161                              <1> %rep %0 - 1
   162                              <1>  %rotate 1
   163                              <1>  %ifidni %1, ELDCALL_CHECK
   164                              <1>   %assign ELDCALL_NEW 0
   165                              <1>   %exitrep
   166                              <1>  %endif
   167                              <1> %endrep
   168                              <1> 	%endmacro
   169                              <1> 
   170                              <1> 	%imacro eldcall_dump_names 1-*.nolist
   171                              <1> %rep %0
   172                              <1> 	%1
   173                              <1>  %rotate 1
   174                              <1> %endrep
   175                              <1> 	%endmacro
   176                              <1> 
   177                              <1> ; eldcall_dump_callcall ELDCALL_CALLCALL_LIST
   178                              <1> ; if using optional code links:
   179                              <1> ;  dw ELDCALL_LINKER_CODE_RELOCATIONS_OPTIONAL, 0
   180                              <1> ;  dw ELDCALL_CODE_RELOCATIONS_OPTIONAL, 0
   181                              <1> ; if not using optional code links:
   182                              <1> ;  dw ELDCALL_LINKER_CODE_RELOCATIONS, 0, 0
   183                              <1> ;  dw ELDCALL_CODE_RELOCATIONS, 0, 0
   184                              <1> ; eldcall_dump_names ELDCALL_CODE_NAMES
   185                              <1> 
   186                              <1> %endif
    10                                  %include "elddata.mac"
     1                              <1> %if 0
     2                              <1> 
     3                              <1> Extensions for lDebug data relocation macros
     4                              <1> 
     5                              <1> Copyright (C) 2008-2024 E. C. Masloch
     6                              <1> 
     7                              <1> Usage of the works is permitted provided that this
     8                              <1> instrument is retained with the works, so that any entity
     9                              <1> that uses the works is notified of this instrument.
    10                              <1> 
    11                              <1> DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
    12                              <1> 
    13                              <1> %endif
    14                              <1> 
    15                              <1> %ifndef ELDDATA_MAC
    16                              <1> %define ELDDATA_MAC 1
    17                              <1> 
    18                              <1> %include "lmacros3.mac"
    19                              <1> %include "nasmhash.mac"
    20                              <1> %include "eldcheck.mac"
    21                              <1> 
    22                              <1> 
    23                              <1> %assign ELDLINKER 0
    24                              <1> 
    25                              <1> %define INTERNAL_CODE_TO_CODE_RELOCATIONS ""
    26                              <1> %define INTERNAL_CODE_TO_DATA_RELOCATIONS ""
    27                              <1> %define INTERNAL_DATA_TO_CODE_RELOCATIONS ""
    28                              <1> %define INTERNAL_DATA_TO_DATA_RELOCATIONS ""
    29                              <1> %define INTERNAL_LINKER_CODE_TO_CODE_RELOCATIONS ""
    30                              <1> %define INTERNAL_LINKER_CODE_TO_DATA_RELOCATIONS ""
    31                              <1> %define INTERNAL_LINKER_DATA_TO_CODE_RELOCATIONS ""
    32                              <1> %define INTERNAL_LINKER_DATA_TO_DATA_RELOCATIONS ""
    33                              <1> %assign ELDDATA_OPTIONAL_STATUS 0		; not any seen yet
    34                              <1> %assign ELDDATA_PMREQUIRED_STATUS 0		; not any seen yet
    35                              <1> 
    36                              <1> 	%imacro internalcoderelocation 0-1.nolist -2
    37                              <1> %assign %%entry $ + _CURRENT_SECTION %+ FIXUP + %1
    38                              <1> %if ELDLINKER
    39                              <1>  %ifidni _CURRENT_SECTION_TYPE, DATA
    40                              <1>   %xdefine INTERNAL_LINKER_DATA_TO_CODE_RELOCATIONS INTERNAL_LINKER_DATA_TO_CODE_RELOCATIONS, %%entry
    41                              <1>  %else
    42                              <1>   %xdefine INTERNAL_LINKER_CODE_TO_CODE_RELOCATIONS INTERNAL_LINKER_CODE_TO_CODE_RELOCATIONS, %%entry
    43                              <1>  %endif
    44                              <1> %else
    45                              <1>  %ifidni _CURRENT_SECTION_TYPE, DATA
    46                              <1>   %xdefine INTERNAL_DATA_TO_CODE_RELOCATIONS INTERNAL_DATA_TO_CODE_RELOCATIONS, %%entry
    47                              <1>  %else
    48                              <1>   %xdefine INTERNAL_CODE_TO_CODE_RELOCATIONS INTERNAL_CODE_TO_CODE_RELOCATIONS, %%entry
    49                              <1>  %endif
    50                              <1> %endif
    51                              <1> 	eldstrictcheck
    52                              <1> 	%endmacro
    53                              <1> 
    54                              <1> 	%imacro internaldatarelocation 0-1.nolist -2
    55                              <1> %assign %%entry $ + _CURRENT_SECTION %+ FIXUP + %1
    56                              <1> %if ELDLINKER
    57                              <1>  %ifidni _CURRENT_SECTION_TYPE, DATA
    58                              <1>   %xdefine INTERNAL_LINKER_DATA_TO_DATA_RELOCATIONS INTERNAL_LINKER_DATA_TO_DATA_RELOCATIONS, %%entry
    59                              <1>  %else
    60                              <1>   %xdefine INTERNAL_LINKER_CODE_TO_DATA_RELOCATIONS INTERNAL_LINKER_CODE_TO_DATA_RELOCATIONS, %%entry
    61                              <1>  %endif
    62                              <1> %else
    63                              <1>  %ifidni _CURRENT_SECTION_TYPE, DATA
    64                              <1>   %xdefine INTERNAL_DATA_TO_DATA_RELOCATIONS INTERNAL_DATA_TO_DATA_RELOCATIONS, %%entry
    65                              <1>  %else
    66                              <1>   %xdefine INTERNAL_CODE_TO_DATA_RELOCATIONS INTERNAL_CODE_TO_DATA_RELOCATIONS, %%entry
    67                              <1>  %endif
    68                              <1> %endif
    69                              <1> 	eldstrictcheck
    70                              <1> 	%endmacro
    71                              <1> 
    72                              <1> ; dw INTERNAL_LINKER_CODE_TO_CODE_RELOCATIONS, 0
    73                              <1> ; dw INTERNAL_LINKER_CODE_TO_DATA_RELOCATIONS, 0
    74                              <1> ; dw INTERNAL_LINKER_DATA_TO_CODE_RELOCATIONS, -1
    75                              <1> ; dw INTERNAL_LINKER_DATA_TO_DATA_RELOCATIONS, -1
    76                              <1> ; dw INTERNAL_CODE_TO_CODE_RELOCATIONS, 0
    77                              <1> ; dw INTERNAL_CODE_TO_DATA_RELOCATIONS, 0
    78                              <1> ; dw INTERNAL_DATA_TO_CODE_RELOCATIONS, -1
    79                              <1> ; dw INTERNAL_DATA_TO_DATA_RELOCATIONS, -1
    80                              <1> 
    81                              <1> 
    82                              <1> %define LINK_DATA_RELOCATIONS ""
    83                              <1> %define LINK_LINKER_DATA_RELOCATIONS ""
    84                              <1> %define LINK_DATA_NAMES db ""
    85                              <1> %define LINK_DATA_DETECTION none, none
    86                              <1> 
    87                              <1> %define LINK_OTHER_DATA_RELOCATIONS ""
    88                              <1> %define LINK_OTHER_LINKER_DATA_RELOCATIONS ""
    89                              <1> %define LINK_OTHER_DATA_NAMES db ""
    90                              <1> %define LINK_OTHER_DATA_DETECTION none, none
    91                              <1> 
    92                              <1> %ifndef ELDOTHER
    93                              <1>  %assign ELDOTHER 0
    94                              <1> %endif
    95                              <1> %assign ELDOTHERLINK 0
    96                              <1> 
    97                              <1> 	%imacro otherlinkdatarelocation 1-3.nolist -2, required
    98                              <1> %if ELDOTHER
    99                              <1>  %assign ELDOTHERLINK 1
   100                              <1> %endif
   101                              <1> 	linkdatarelocation %1, %2, %3
   102                              <1> %assign ELDOTHERLINK 0
   103                              <1> 	%endmacro
   104                              <1> 
   105                              <1> 	%imacro linkdatarelocation 1-3.nolist -2, required
   106                              <1> %assign %%entry $ + _CURRENT_SECTION %+ FIXUP + %2
   107                              <1> %ifidni %3, required
   108                              <1>  %assign %%optional 0
   109                              <1> %elifidni %3, optional
   110                              <1>  %assign %%optional 100h
   111                              <1>  %if ELDDATA_OPTIONAL_STATUS == 0
   112                              <1>   %assign ELDDATA_OPTIONAL_STATUS 1
   113                              <1>  %elif ELDDATA_OPTIONAL_STATUS == 1
   114                              <1>  %else
   115                              <1>   %error Optional data link not allowed here
   116                              <1>  %endif
   117                              <1> %elifidni %3, PM required
   118                              <1>  %assign %%optional 300h
   119                              <1>  %assign ELDDATA_PMREQUIRED_STATUS 1
   120                              <1>  %if ELDDATA_OPTIONAL_STATUS == 0
   121                              <1>   %assign ELDDATA_OPTIONAL_STATUS 1
   122                              <1>  %elif ELDDATA_OPTIONAL_STATUS == 1
   123                              <1>  %else
   124                              <1>   %error Optional data link not allowed here
   125                              <1>  %endif
   126                              <1> %else
   127                              <1>  %fatal Unknown optional keyword
   128                              <1> %endif
   129                              <1> %ifidni _CURRENT_SECTION_TYPE, DATA
   130                              <1>  %assign %%DATASECTION 1
   131                              <1> %else
   132                              <1>  %assign %%DATASECTION 0
   133                              <1> %endif
   134                              <1> 	%if ELDOTHERLINK
   135                              <1> %if ELDLINKER
   136                              <1>  %xdefine LINK_OTHER_LINKER_DATA_RELOCATIONS LINK_OTHER_LINKER_DATA_RELOCATIONS, 1 + %%DATASECTION + %%optional, %%entry, %%name
   137                              <1> %else
   138                              <1>  %xdefine LINK_OTHER_DATA_RELOCATIONS LINK_OTHER_DATA_RELOCATIONS, 1 + %%DATASECTION + %%optional, %%entry, %%name
   139                              <1> %endif
   140                              <1> 	%else
   141                              <1> %if ELDLINKER
   142                              <1>  %xdefine LINK_LINKER_DATA_RELOCATIONS LINK_LINKER_DATA_RELOCATIONS, 1 + %%DATASECTION + %%optional, %%entry, %%name
   143                              <1> %else
   144                              <1>  %xdefine LINK_DATA_RELOCATIONS LINK_DATA_RELOCATIONS, 1 + %%DATASECTION + %%optional, %%entry, %%name
   145                              <1> %endif
   146                              <1> 	%endif
   147                              <1> %defstr %%string %1
   148                              <1> %strlen %%length %%string
   149                              <1> %if %%length > 64
   150                              <1>  %error Too long link name: %1
   151                              <1> %endif
   152                              <1> %define LINK_DATA_CHECK %1
   153                              <1> 	%if ELDOTHERLINK
   154                              <1> 	linkdata_detect LINK_OTHER_DATA_DETECTION
   155                              <1> %if LINK_DATA_NEW
   156                              <1>  %xdefine LINK_OTHER_DATA_DETECTION LINK_OTHER_DATA_DETECTION, %1, %%name
   157                              <1> 	hashdef HASH, %%string
   158                              <1>  %xdefine LINK_OTHER_DATA_NAMES 	LINK_OTHER_DATA_NAMES, %%name:, dw _HASH, {counted %%string}
   160                              <1> %else
   161                              <1>  %%name equ LINK_DATA_DUPLICATE
   162                              <1> %endif
   163                              <1> 	%else
   164                              <1> 	linkdata_detect LINK_DATA_DETECTION
   165                              <1> %if LINK_DATA_NEW
   166                              <1>  %xdefine LINK_DATA_DETECTION LINK_DATA_DETECTION, %1, %%name
   167                              <1> 	hashdef HASH, %%string
   168                              <1>  %xdefine LINK_DATA_NAMES 	LINK_DATA_NAMES, %%name:, dw _HASH, {counted %%string}
   170                              <1> %else
   171                              <1>  %%name equ LINK_DATA_DUPLICATE
   172                              <1> %endif
   173                              <1> 	%endif
   174                              <1> 	eldstrictcheck
   175                              <1> 	%endmacro
   176                              <1> 
   177                              <1> 	%imacro linkdata_detect 2-*.nolist
   178                              <1> %assign LINK_DATA_NEW 1
   179                              <1> %rep (%0 - 2) / 2
   180                              <1>  %rotate 2
   181                              <1>  %ifidni %1, LINK_DATA_CHECK
   182                              <1>   %assign LINK_DATA_NEW 0
   183                              <1>   %xdefine LINK_DATA_DUPLICATE %2
   184                              <1>   %exitrep
   185                              <1>  %endif
   186                              <1> %endrep
   187                              <1> 	%endmacro
   188                              <1> 
   189                              <1> 	%imacro link_data_dump_names 1-*.nolist
   190                              <1> %rep %0
   191                              <1> 	%1
   192                              <1>  %rotate 1
   193                              <1> %endrep
   194                              <1> 	%endmacro
   195                              <1> 
   196                              <1> ; dw LINK_LINKER_DATA_RELOCATIONS, 0, 0
   197                              <1> ; dw LINK_DATA_RELOCATIONS, 0, 0
   198                              <1> ; link_data_dump_names ELDCALL_CODE_NAMES
   199                              <1> 
   200                              <1> %endif
    11                                  
    12                                  	cpu 8086
    13                                  
    14                                  	addsection RELOCATEDDATA, nobits vstart=_ELD_RELOC_VSTART
    15                                  relocateddata:
    16                                  
    17                                  	addsection HEADER, start=0
    18                                  
    19                                  	istruc ELD_HEADERX
    20                                  at eldhxHeader
    21                                  		; ELD executable header
    22                                  	istruc ELD_HEADER
    23 00000000 454C4431                at eldhSignature,	db "ELD1"
    24 00000004 000000                  			db 0,0,0
    25 00000007 1A                      			db 26
    26 00000008 50000000                at eldhCodeOffset,	dd CODEOFFSET
    27 0000000C D009                    at eldhCodeImageLength,	dw code_size
    28 0000000E 0000                    at eldhCodeAllocLength,	dw 0
    29 00000010 200A0000                at eldhDataOffset,	dd DATAOFFSET
    30 00000014 B001                    at eldhDataImageLength,	dw data_size
    31 00000016 0000                    at eldhDataAllocLength,	dw total_data_size - data_size
    32 00000018 9002                    at eldhCodeEntrypoint,	dw linker - code
    33                                  at eldhReserved
    34 0000001A 00<rep 4h>2800          at eldhExtensionSize,	dw header_extension_end - $$
    35                                  	iend
    36 00000020 [30000000]              at eldhxDescriptionOffset,	dd description
    37 00000024 F00A0000                at eldhxHelpOffset,		dd DATAOFFSET + msg.help - datastart
    38                                  PUT_ELDHX_DATETIME_OFFSET
    39                                  header_extension_end:
    40 00000028 00<rep 8h>              	iend
    41                                  
    42 00000030 50726F766964652048-     description:		asciz "Provide HISTORY utility."
    42 00000039 4953544F5259207574-
    42 00000042 696C6974792E00     
    43                                  
    44                                  
    45 00000049 00<rep 7h>              	align 16, db 0
    46                                  
    47                                  CODEOFFSET equ $ - $$
    48                                  	addsection CODE, follows=HEADER vstart=_ELD_CODE_VSTART
    49                                  %define CODEFIXUP - code + 0
    50                                  code:
    51                                  		; ELD instance header
    52                                  	istruc ELD_INSTANCE
    53                                  at eldiStartCode
    54 00000000 00<rep 2h>              at eldiEndCode
    55 00000002 00<rep 2h>              at eldiStartData
    56 00000004 00<rep 2h>              at eldiEndData
    57 00000006 00<rep 2h>48495354-     at eldiIdentifier,	fill 8, 32, db "HISTORY"
    57 0000000C 4F525920           
    58 00000010 00<rep 2h>68697374-     at eldiListing,		asciz _ELD_LISTING
    58 00000016 6F72792E6C737400   
    59 0000001E 00<rep 2h>              	iend
    60                                  
    61                                  
    62                                  command:
    63 00000020 EB08                    	jmp strict short .entry
    64                                  .chain:
    65 00000022 E8[0000]EB020000        	extcall cmd3_not_ext, required	; must NOT be extcallcall
    66 00000029 90                      	times 10 - ($ - command) nop
    67                                  .entry:
    68 0000002A 56                      	push si
    69 0000002B 3C2D                    	cmp al, '-'
    70 0000002D 7503                    	jne @F
    71 0000002F E86E01                  	extcallcall skipcomma
    72                                  @@:
    73 00000032 4E                      	dec si
    74                                  
    75 00000033 BA[0000]                	mov dx, msg.history
    76                                  internaldatarelocation
    77 00000036 E86F01                  	extcallcall isstring?
    78 00000039 7405                    	je .ours
    79 0000003B 5E                      	pop si
    80 0000003C 4E                      	dec si
    81 0000003D AC                      	lodsb
    82 0000003E EBE2                    	jmp .chain
    83                                  
    84                                  .ours:
    85 00000040 58                      	pop ax
    86 00000041 E85C01                  	extcallcall skipcomma
    87 00000044 4E                      	dec si
    88 00000045 C706[0000][0000]        reloc2	mov word [relocateddata], relocateddata
    89                                  linkdatarelocation lastcmd, -4
    90                                  linkdatarelocation dmycmd
    91 0000004B BA[0000]                	mov dx, relocateddata
    92                                  linkdatarelocation msg.uninstall
    93 0000004E E85701                  	extcallcall isstring?
    94 00000051 741D                    	je uninstall
    95 00000053 BA[0800]                	mov dx, msg.clear
    96                                  internaldatarelocation
    97 00000056 E84F01                  	extcallcall isstring?
    98 00000059 7410                    	je clear
    99 0000005B BA[0E00]                	mov dx, msg.show
   100                                  internaldatarelocation
   101 0000005E E84701                  	extcallcall isstring?
   102                                  	; je
   103 00000061 AC                      	lodsb
   104 00000062 E84B01                  	extcallcall chkeol
   105 00000065 E88E00                  	call run_show
   106                                  @@:
   107 00000068 E84D01                  	extcallcall cmd3
   108                                  
   109                                  clear:
   110 0000006B E87E00                  	call run_clear
   111 0000006E EBF8                    	jmp @B
   112                                  
   113                                  uninstall:
   114 00000070 AC                      	lodsb
   115 00000071 E83C01                  	extcallcall chkeol
   116                                  
   117 00000074 8E06[0000]              	mov es, word [relocateddata]
   118                                  linkdatarelocation extdssel
   119 00000078 E84501                  	extcallcall ispm
   120 0000007B 7404                    	jz @F
   121 0000007D 8E06[0000]              	mov es, word [relocateddata]
   122                                  linkdatarelocation extseg
   123                                  @@:
   124 00000081 06                      	push es
   125 00000082 1F                      	pop ds
   126 00000083 31DB                    	xor bx, bx		; = 0 (no prior, modify ext_command_handler)
   127 00000085 BF[2000]                	mov di, command		; di -> us
   128                                  internalcoderelocation
   129 00000088 368B36[0000]            	mov si, word [ss:relocateddata]
   130                                  linkdatarelocation ext_command_handler
   131                                  				; si -> first
   132 0000008D 85F6                    	test si, si		; none installed ?
   133 0000008F 7450                    	jz .error		; error -->
   134                                  
   135                                  .loop:
   136 00000091 39F7                    	cmp di, si		; found ?
   137 00000093 740D                    	je .bx			; yes, use bx -->
   138 00000095 89F3                    	mov bx, si		; bx -> prior handler
   139 00000097 AD                      	lodsw			; skip entrypoint jmp strict short
   140 00000098 AC                      	lodsb			; get first byte of chainer
   141 00000099 3CE9                    	cmp al, 0E9h		; expecting jmp near ?
   142 0000009B 7544                    	jne .error		; no, error -->
   143 0000009D AD                      	lodsw			; get rel16 displacement
   144 0000009E 01C6                    	add si, ax		; -> next handler
   145 000000A0 EBEF                    	jmp .loop
   146                                  
   147                                  .bx:
   148 000000A2 85DB                    	test bx, bx		; any prior ?
   149 000000A4 751A                    	jnz .bxnz		; yes -->
   150 000000A6 AF                      	scasw			; skip entrypoint jmp strict short
   151 000000A7 803DE8                  	cmp byte [di], 0E8h	; is it a call to cmd3_not_ext ?
   152 000000AA 7507                    	jne @F			; no -->
   153                                  				; yes, reset ext_command_handler to zero
   154                                  .setbx:
   155 000000AC 36891E[0000]            	mov word [ss:relocateddata], bx
   156                                  linkdatarelocation ext_command_handler
   157 000000B1 EB1E                    	jmp .done
   158                                  
   159                                  @@:
   160 000000B3 803DE9                  	cmp byte [di], 0E9h	; validate
   161 000000B6 7529                    	jne .error		; failure -->
   162 000000B8 47                      	inc di			; -> rel16 displacement
   163 000000B9 8B1D                    	mov bx, word [di]	; get displacement
   164 000000BB AF                      	scasw			; -> after jmp near
   165 000000BC 01FB                    	add bx, di		; -> next handler
   166 000000BE EBEC                    	jmp .setbx		; set ext_command_handler to next
   167                                  
   168                                  .bxnz:
   169 000000C0 89DE                    	mov si, bx		; -> prior handler with us as downlink
   170 000000C2 87FE                    	xchg di, si		; si -> ours, di -> prior
   171 000000C4 A7                      	cmpsw			; skip entrypoint jmp strict short
   172 000000C5 A4                      	movsb			; copy 0E8h/0E9h
   173 000000C6 AD                      	lodsw			; ax = near rel16 displacement
   174 000000C7 01F0                    	add ax, si		; add in our base (= absolute offset)
   175 000000C9 29F8                    	sub ax, di
   176 000000CB 48                      	dec ax
   177 000000CC 48                      	dec ax			; subtract new base (= relative displacement)
   178 000000CD AB                      	stosw			; store new rel16 displacement
   179 000000CE A5                      	movsw			; jmp strict short
   180 000000CF A5                      	movsw			; linkcall target
   181 000000D0 A4                      	movsb			; trailer
   182                                  .done:
   183 000000D1 8026[1000]FE            	clropt [code + eldiFlags], eldifResident
   184                                  internalcoderelocation -3	; mark block as free
   185 000000D6 BA[1300]                	mov dx, msg.uninstall_done
   186                                  internaldatarelocation
   187                                  @@:
   188 000000D9 16                      	push ss
   189 000000DA 1F                      	pop ds
   190 000000DB E8EA00                  	extcallcall putsz
   191 000000DE E8D700                  	extcallcall cmd3	; return
   192                                  
   193                                  .error:
   194 000000E1 B8010E                  	mov ax, 0E01h
   195 000000E4 E8E900                  	extcallcall setrc
   196 000000E7 BA[3200]                	mov dx, msg.uninstall_error
   197                                  internaldatarelocation
   198 000000EA EBED                    	jmp @B
   199                                  
   200                                  
   201                                  run_clear:
   202 000000EC E88E00                  	call get_history_first_last
   203 000000EF 8B07                    	mov ax, word [bx]
   204 000000F1 87D3                    	xchg dx, bx
   205 000000F3 8907                    	mov word [bx], ax
   206 000000F5 C3                      	retn
   207                                  
   208                                  
   209                                  run_show:
   210                                  	houdini
   211 000000F6 16                      	push ss
   212 000000F7 07                      	pop es
   213 000000F8 C606[D000]00            	mov byte [history_data_entry], 0
   214                                  internaldatarelocation -3
   215 000000FD B8[0000]                	mov ax, relocateddata
   216                                  linkdatarelocation historyformat, -2, optional
   217 00000100 85C0                    	test ax, ax
   218 00000102 750E                    	jnz @F
   219 00000104 B83D0E                  	mov ax, 0E3Dh
   220 00000107 E8C600                  	extcallcall setrc
   221 0000010A BA[5900]                	mov dx, msg.history_none
   222                                  internaldatarelocation
   223                                  .putsz_end:
   224 0000010D E8B800                  	extcallcall putsz
   225 00000110 EB6A                    	jmp .end
   226                                  
   227                                  @@:
   228 00000112 83F802                  	cmp ax, 2
   229 00000115 720D                    	jb .in_data_entry
   230 00000117 740F                    	je .in_separate
   231                                  
   232 00000119 B83E0E                  	mov ax, 0E3Eh
   233 0000011C E8B100                  	extcallcall setrc
   234 0000011F BA[7B00]                	mov dx, msg.history_unknown
   235                                  internaldatarelocation
   236 00000122 EBE9                    	jmp .putsz_end
   237                                  
   238                                  .in_data_entry:
   239 00000124 F616[D000]              	not byte [history_data_entry]
   240                                  internaldatarelocation
   241                                  .in_separate:
   242 00000128 E85200                  	call get_history_first_last
   243 0000012B 89D6                    	mov si, dx
   244 0000012D 87F3                    	xchg si, bx
   245 0000012F 8B34                    	mov si, [si]
   246 00000131 8B1F                    	mov bx, [bx]
   247                                  houdini
   248 00000133 4E                      	dec si
   249 00000134 4E                      	dec si
   250 00000135 31D2                    	xor dx, dx
   251 00000137 D006[D000]              	rol byte [history_data_entry], 1
   252                                  internaldatarelocation
   253 0000013B 730A                    	jnc .not_entry
   254 0000013D BA[0000]                	mov dx, relocateddata
   255                                  linkdatarelocation historybuffer, -2, optional
   256 00000140 85D2                    	test dx, dx
   257 00000142 7503                    	jnz @F
   258 00000144 E84400                  	call history_missing
   259                                  @@:
   260                                  .not_entry:
   261                                  
   262                                  .loop:
   263 00000147 BF[0000]                	mov di, relocateddata
   264                                  linkdatarelocation line_out
   265 0000014A 39DE                    	cmp si, bx
   266 0000014C 722E                    	jb .done
   267                                  
   268 0000014E D006[D000]              	rol byte [history_data_entry], 1
   269                                  internaldatarelocation
   270 00000152 720B                    	jc .not_seg
   271 00000154 53                      	push bx
   272 00000155 BB[0000]                	mov bx, relocateddata
   273                                  linkdatarelocation history.segorsel, -2, optional
   274 00000158 85DB                    	test bx, bx
   275 0000015A 742F                    	jz history_missing	; bx on stack discarded
   276 0000015C 8E1F                    	mov ds, word [bx]
   277 0000015E 5B                      	pop bx
   278                                  .not_seg:
   279                                  	; extcallcall decword
   280 0000015F AD                      	lodsw			; ax -> behind entry
   281 00000160 01D0                    	add ax, dx
   282 00000162 8B0C                    	mov cx, [si]		; cx -> behind prior entry, start of this
   283 00000164 01D1                    	add cx, dx
   284 00000166 96                      	xchg ax, si		; si -> behind
   285 00000167 29CE                    	sub si, cx		; si = length
   286 00000169 87F1                    	xchg si, cx		; cx = length, si -> text
   287 0000016B F3A4                    	rep movsb
   288 0000016D 96                      	xchg ax, si		; restore si -> next high array entry
   289 0000016E 83EE04                  	sub si, 4
   290 00000171 16                      	push ss
   291 00000172 1F                      	pop ds
   292 00000173 52                      	 push dx
   293 00000174 53                      	 push bx
   294 00000175 E86000                  	extcallcall putsline_crlf
   295 00000178 5B                      	 pop bx
   296 00000179 5A                      	 pop dx
   297 0000017A EBCB                    	jmp .loop
   298                                  
   299                                  .done:
   300                                  .end:
   301 0000017C C3                      	retn
   302                                  
   303                                  
   304                                  get_history_first_last:
   305 0000017D BB[0000]                	mov bx, relocateddata
   306                                  linkdatarelocation history.first, -2, optional
   307 00000180 BA[0000]                	mov dx, relocateddata
   308                                  linkdatarelocation history.last, -2, optional
   309 00000183 85DB                    	test bx, bx
   310 00000185 7404                    	jz @F
   311 00000187 85D2                    	test dx, dx
   312 00000189 750D                    	jnz @FF
   313                                  
   314                                  @@:
   315                                  history_missing:
   316 0000018B B83F0E                  	mov ax, 0E3Fh
   317 0000018E E83F00                  	extcallcall setrc
   318 00000191 BA[9700]                	mov dx, msg.history_missing
   319                                  internaldatarelocation
   320 00000194 E83100                  	extcallcall putsz
   321 00000197 59                      	pop cx
   322                                  @@:
   323 00000198 C3                      	retn
   324                                  
   325                                  
   326 00000199 90<rep 7h>E8[0000]-     	eldcall_dump_callcall ELDCALL_CALLCALL_LIST
   326 000001A3 EB020000C3E8[0000]-
   326 000001AB EB020000C3E8[0000]-
   326 000001B3 EB020000C3E8[0000]-
   326 000001BB EB020000C3E8[0000]-
   326 000001C3 EB020000C3E8[0000]-
   326 000001CB EB020000C3E8[0000]-
   326 000001D3 EB020000C3E8[0000]-
   326 000001DB EB020000C3         
   327                                  
   328                                  endinstalled equ ($ + CODEFIXUP + 15) & ~15
   329                                  
   330                                  
   331                                  start:
   332 000001E0 8CC3                    	mov bx, es
   333 000001E2 16                      	 push ss
   334 000001E3 07                      	 pop es
   335 000001E4 E8B9FF                  	call skipcomma
   336 000001E7 4E                      	dec si
   337 000001E8 BA[0000]                	mov dx, relocateddata
   338                                  linkdatarelocation msg.install
   339 000001EB E8BAFF                  	call isstring?
   340 000001EE 744D                    	je install
   341 000001F0 BA[0E00]                	mov dx, msg.show
   342                                  internaldatarelocation
   343 000001F3 E8B2FF                  	call isstring?
   344 000001F6 7418                    	je .show
   345 000001F8 BA[0800]                	mov dx, msg.clear
   346                                  internaldatarelocation
   347 000001FB E8AAFF                  	call isstring?
   348 000001FE 7415                    	je .clear
   349                                  
   350 00000200 AC                      	lodsb
   351 00000201 E8ACFF                  	call chkeol
   352 00000204 BA[D000]                	mov dx, msg.help
   353                                  internaldatarelocation
   354 00000207 E8BEFF                  	call putsz
   355                                  @@:
   356 0000020A E80D00                  	call uninstall_oneshot
   357 0000020D 31C0                    	xor ax, ax
   358 0000020F CB                      	retf
   359                                  
   360                                  .show:
   361 00000210 E8E3FE                  	call run_show
   362 00000213 EBF5                    	jmp @B
   363                                  
   364                                  .clear:
   365 00000215 E8D4FE                  	call run_clear
   366 00000218 EBF0                    	jmp @B
   367                                  
   368                                  
   369                                  uninstall_oneshot:
   370 0000021A 36F606[0000]01          	testopt [ss:relocateddata], 1
   371                                  linkdatarelocation options7, -3
   372 00000220 751A                    	jnz @F
   373                                  
   374 00000222 2EA1[0200]              	mov ax, word [cs:code + eldiEndCode]
   375                                  internalcoderelocation
   376 00000226 2E2B06[0000]            	sub ax, word [cs:code + eldiStartCode]
   377                                  internalcoderelocation
   378 0000022B 2906[0000]              	sub word [relocateddata], ax
   379                                  linkdatarelocation extseg_used
   380                                  
   381 0000022F 2EA1[0600]              	mov ax, word [cs:code + eldiEndData]
   382                                  internalcoderelocation
   383 00000233 2E2B06[0400]            	sub ax, word [cs:code + eldiStartData]
   384                                  internalcoderelocation
   385 00000238 2906[0000]              	sub word [relocateddata], ax
   386                                  linkdatarelocation extdata_used
   387                                  @@:
   388 0000023C C3                      	retn
   389                                  
   390                                  
   391                                  DATAOFFSET equ CODEOFFSET + code_size
   392                                  	addsection DATA, follows=CODE vstart=_ELD_DATA_VSTART
   393                                  %define DATAFIXUP - datastart + 0
   394                                  datastart:
   395                                  PUT_ELD_DATETIME
   396                                  
   397                                  msg:
   398 00000000 484953544F525900        .history:		asciz "HISTORY"
   399 00000008 434C45415200            .clear:			asciz "CLEAR"
   400 0000000E 53484F5700              .show:			asciz "SHOW"
   401 00000013 484953544F52592075-     .uninstall_done:	db "HISTORY utility uninstalled."
   401 0000001C 74696C69747920756E-
   401 00000025 696E7374616C6C6564-
   401 0000002E 2E                 
   402                                  %if _ELD_RECLAIM_HINT
   403                                  			db " (Don't forget to use reclaim.eld)"
   404                                  %endif
   405 0000002F 0D0A00                  			asciz 13,10
   406 00000032 484953544F52592075-     .uninstall_error:	asciz "HISTORY utility unable to uninstall!",13,10
   406 0000003B 74696C69747920756E-
   406 00000044 61626C6520746F2075-
   406 0000004D 6E696E7374616C6C21-
   406 00000056 0D0A00             
   407 00000059 0D0A4E6F2068697374-     .history_none:		asciz 13,10,"No history format link found.",13,10
   407 00000062 6F727920666F726D61-
   407 0000006B 74206C696E6B20666F-
   407 00000074 756E642E0D0A00     
   408 0000007B 0D0A556E6B6E6F776E-     .history_unknown:	asciz 13,10,"Unknown history format.",13,10
   408 00000084 20686973746F727920-
   408 0000008D 666F726D61742E0D0A-
   408 00000096 00                 
   409 00000097 486973746F7279206C-     .history_missing:	asciz "History last or first displacement or segment missing.",13,10
   409 000000A0 617374206F72206669-
   409 000000A9 72737420646973706C-
   409 000000B2 6163656D656E74206F-
   409 000000BB 72207365676D656E74-
   409 000000C4 206D697373696E672E-
   409 000000CD 0D0A00             
   410                                  
   411                                  uinit_data: equ $
   412                                  
   413 000000D0 484953544F52592075-     .help:		db "HISTORY utility. Available commands:",13,10
   413 000000D9 74696C6974792E2041-
   413 000000E2 7661696C61626C6520-
   413 000000EB 636F6D6D616E64733A-
   413 000000F4 0D0A               
   414 000000F6 0D0A                    		db 13,10
   415 000000F8 53484F57090953686F-     		db "SHOW",9,9,"Show all of history",13,10
   415 00000101 7720616C6C206F6620-
   415 0000010A 686973746F72790D0A 
   416 00000113 434C4541520909436C-     		db "CLEAR",9,9,"Clear history",13,10
   416 0000011C 65617220686973746F-
   416 00000125 72790D0A           
   417 00000129 494E5354414C4C0909-     		db "INSTALL",9,9,"(ELD load only) Install utility resident",13,10
   417 00000132 28454C44206C6F6164-
   417 0000013B 206F6E6C792920496E-
   417 00000144 7374616C6C20757469-
   417 0000014D 6C6974792072657369-
   417 00000156 64656E740D0A       
   418 0000015C 554E494E5354414C4C-     		db "UNINSTALL",9,"(Resident only) Uninstall resident utility",13,10
   418 00000165 09285265736964656E-
   418 0000016E 74206F6E6C79292055-
   418 00000177 6E696E7374616C6C20-
   418 00000180 7265736964656E7420-
   418 00000189 7574696C6974790D0A 
   419 00000192 00                      		asciz
   420 00000193 484953544F52592075-     .installed:		asciz "HISTORY utility installed.",13,10
   420 0000019C 74696C69747920696E-
   420 000001A5 7374616C6C65642E0D-
   420 000001AE 0A00               
   421                                  
   422                                  	align 16, db 0
   423                                  init_data_end:
   424                                  data_size equ $ - datastart
   425                                  transient_data_size equ data_size
   426                                  
   427                                  	absolute uinit_data
   428                                  history_data_entry:
   429 000000D0 ??                      	resb 1
   430                                  
   431 000000D1 <res Fh>                	alignb 16
   432                                  uinit_data_end:
   433                                  resident_data_end:
   434                                  resident_data_size equ resident_data_end - datastart
   435                                  
   436                                  %if uinit_data_end >= init_data_end
   437                                   total_data_size equ $ - datastart
   438                                  %else
   439                                   total_data_size equ init_data_end - datastart
   440                                  %endif
   441                                  %assign _DATA_SIZE total_data_size
   442                                  
   443                                  
   444                                  	usesection CODE
   445                                  
   446                                  install:
   447 0000023D AC                      	lodsb
   448 0000023E E8[0000]EB020000        	extcall chkeol
   449                                  
   450                                  	houdini
   451 00000245 8EC3                    	mov es, bx		; => ext seg (writable)
   452                                  
   453 00000247 B8B000                  	mov ax, endresident - endinstalled
   454 0000024A 262906[0200]            	sub word [es:code + eldiEndCode], ax
   455                                  internalcoderelocation		; adjust size
   456 0000024F 2906[0000]              	sub word [relocateddata], ax
   457                                  linkdatarelocation extseg_used	; adjust size
   458                                  
   459                                  %if (transient_data_size - resident_data_size) > 0
   460 00000253 B8D000                  	mov ax, transient_data_size - resident_data_size
   461 00000256 262906[0600]            	sub word [es:code + eldiEndData], ax
   462                                  internalcoderelocation		; adjust size
   463 0000025B 2906[0000]              	sub word [relocateddata], ax
   464                                  linkdatarelocation extdata_used	; adjust size
   465                                  %endif
   466                                  
   467 0000025F 8B1E[0000]              	mov bx, word [relocateddata]
   468                                  linkdatarelocation ext_command_handler
   469                                  				; -> prior
   470 00000263 BF[2000]                	mov di, command		; -> our handler
   471                                  internalcoderelocation
   472 00000266 85DB                    	test bx, bx		; installing as first ?
   473 00000268 740A                    	jz .only_first		; yes, simple --> (leave as extcall cmd3_not_ext)
   474 0000026A AF                      	scasw			; skip entrypoint jmp strict short
   475 0000026B B0E9                    	mov al, 0E9h		; = jmp near opcode
   476 0000026D AA                      	stosb			; store
   477 0000026E 93                      	xchg ax, bx		; ax -> next handler
   478 0000026F 29F8                    	sub ax, di
   479 00000271 48                      	dec ax
   480 00000272 48                      	dec ax			; ax = ax - (di + 2)
   481 00000273 AB                      	stosw			; store our downlink as rel16 displacement
   482                                  
   483                                  .only_first:
   484 00000274 26800E[1000]01          	setopt [es:code + eldiFlags], eldifResident
   485                                  internalcoderelocation -3	; mark block as resident
   486 0000027A C706[0000][2000]        	mov word [relocateddata], command
   487                                  linkdatarelocation ext_command_handler, -4
   488                                  internalcoderelocation		; -> our entrypoint
   489                                  
   490 00000280 F606[0000]04            	testopt [relocateddata], 4
   491                                  linkdatarelocation options7, -3
   492 00000285 7506                    	jnz @F
   493 00000287 BA[9301]                	mov dx, msg.installed
   494                                  internaldatarelocation
   495 0000028A E83BFF                  	call putsz
   496                                  @@:
   497 0000028D 31C0                    	xor ax, ax
   498 0000028F CB                      	retf
   499                                  
   500                                  
   501                                  %include "eldlink.asm"
     1                              <1> %if 0
     2                              <1> 
     3                              <1> Extensions for lDebug linker
     4                              <1> 
     5                              <1> Copyright (C) 2008-2024 E. C. Masloch
     6                              <1> 
     7                              <1> Usage of the works is permitted provided that this
     8                              <1> instrument is retained with the works, so that any entity
     9                              <1> that uses the works is notified of this instrument.
    10                              <1> 
    11                              <1> DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
    12                              <1> 
    13                              <1> %endif
    14                              <1> 
    15                              <1> %include "lmacros3.mac"
     1                              <2> [list -]
    16                              <1> %include "eld.mac"
     1                              <2> %if 0
     2                              <2> 
     3                              <2> Extensions for lDebug macros
     4                              <2> 
     5                              <2> Copyright (C) 2008-2023 E. C. Masloch
     6                              <2> 
     7                              <2> Usage of the works is permitted provided that this
     8                              <2> instrument is retained with the works, so that any entity
     9                              <2> that uses the works is notified of this instrument.
    10                              <2> 
    11                              <2> DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.
    12                              <2> 
    13                              <2> %endif
    14                              <2> 
    15                              <2> %ifndef ELD_MAC
    16                              <2> %define ELD_MAC 1
    17                              <2> 
    18                              <2> %include "lmacros3.mac"
    19                              <2> 
    20                              <2> 		; ELD executable header
    21                              <2> 	struc ELD_HEADER
    22                              <2> eldhSignature:		resb 4	; "ELD1"
    23                              <2> 			resb 3	; reserved
    24                              <2> 			resb 1	; 26 (Ctrl-Z)
    25                              <2> eldhCodeOffset:		resd 1	; position displacement from eldhSignature
    26                              <2> eldhCodeImageLength:	resw 1	; amount bytes, at least 32
    27                              <2> eldhCodeAllocLength:	resw 1	; amount bytes, added to prior. sum < 64 KiB
    28                              <2> eldhDataOffset:		resd 1
    29                              <2> eldhDataImageLength:	resw 1	; (zero allowed)
    30                              <2> eldhDataAllocLength:	resw 1	; (zero allowed)
    31                              <2> eldhCodeEntrypoint:	resw 1	; within code section, used as displacement
    32                              <2> eldhReserved:		resb 4	; reserved
    33                              <2> eldhExtensionSize:	resw 1	; from eldhSignature, -> past eldhx fields in use
    34                              <2> 	endstruc
    35                              <2> 	endarea ELD_HEADER, 1
    36                              <2> 
    37                              <2> 	struc ELD_HEADERX
    38                              <2> eldhxHeader:		resb ELD_HEADER_size
    39                              <2> eldhxDescriptionOffset:	resd 1	; zero if none, from eldhxHeader. <= 128 Bytes
    40                              <2> eldhxHelpOffset:	resd 1	; zero if none, from eldhxHeader
    41                              <2> eldhxLibTable:		resd 1	; zero if none, from eldhxHeader
    42                              <2> eldhxDateTimeOffset:	resd 1	; zero if none, from eldhxHeader
    43                              <2> 	alignb 16
    44                              <2> 	endstruc
    45                              <2> 
    46                              <2> 	struc ELD_TRAILER_HEADER
    47                              <2> eldthSignature:		resb 8	; "ELD1TAIL"
    48                              <2> eldthHeaderOffset:	resd 1	; negative displacement from eldthSignature,
    49                              <2> 				;  add this dword to the seek offset
    50                              <2> eldthReserved:		resw 1	; reserved, must be initialised to zero
    51                              <2> eldthChecksum:		resw 1	; sum of all words in trailer header = 0
    52                              <2> 	endstruc
    53                              <2> 	endarea ELD_TRAILER_HEADER, 1
    54                              <2> 
    55                              <2> 	struc ELD_LIBTABLE
    56                              <2> eldltFormat:		resw 1	; current: 0 = uncompressed, 2 = compressed
    57                              <2> eldltAmount:		resw 1
    58                              <2> eldltOffset:		resd 1	; from eldhxHeader
    59                              <2> eldltCompressedLength:		; (dword, only present if format 2)
    60                              <2> 	endstruc
    61                              <2> 	endarea ELD_LIBTABLE, 1
    62                              <2> 
    63                              <2> 		; ELD instance header
    64                              <2> 	struc ELD_INSTANCE
    65                              <2> eldiStartCode:		resw 1	; -> this structure itself (para aligned)
    66                              <2> eldiEndCode:		resw 1	; -> behind memory used by instance (para aligned)
    67                              <2> eldiStartData:		resw 1	; -> data in data entry section (para aligned), or 0
    68                              <2> eldiEndData:		resw 1	; -> behind data (para aligned), or 0
    69                              <2> eldiIdentifier:		resb 8	; blank-filled text
    70                              <2> eldiFlags:		resw 1	; flags
    71                              <2> eldiListing_size equ 14
    72                              <2> eldiListing:		resb eldiListing_size
    73                              <2> 				; ASCIZ listing file name
    74                              <2> 	endstruc
    75                              <2> 		; flags for eldiFlags:
    76                              <2> eldifResident:		equ 1
    77                              <2> 
    78                              <2> 		; ELD link info header
    79                              <2> 	struc ELD_LINKINFO
    80                              <2> eldlSignature:		resw 1	; 0E1D1h
    81                              <2> eldlReserved:		resw 2
    82                              <2> eldlUseLinkHash:	resw 1
    83                              <2> eldlDataAmount:		resw 1
    84                              <2> eldlDataPrefixes:	resw 1
    85                              <2> eldlDataEntries:	resw 1
    86                              <2> eldlDataAddresses:	resw 1
    87                              <2> eldlCodeAmount:		resw 1
    88                              <2> eldlCodePrefixes:	resw 1
    89                              <2> eldlCodeEntries:	resw 1
    90                              <2> eldlCodeAddresses:	resw 1
    91                              <2> 	endstruc
    92                              <2> 
    93                              <2> 	numdef ELD_CODE_VSTART, 9001h
    94                              <2> 	numdef ELD_DATA_VSTART, 8000h
    95                              <2> 	numdef ELD_RELOC_VSTART, 8000h
    96                              <2> 
    97                              <2> 	numdef ELD_RECLAIM_HINT, 0
    98                              <2> 	strdef ELD_LISTING, ""
    99                              <2> 	numdef ELD_DATETIME, 0
   100                              <2> 
   101                              <2> %if _ELD_DATETIME
   102                              <2>  %define PUT_ELDHX_DATETIME_OFFSET at eldhxDateTimeOffset, dd DATAOFFSET + datetime - datastart
   103                              <2>  %macro PUT_ELD_DATETIME 0.nolist
   104                              <2> datetime:	asciz __UTC_DATE__,'T',__UTC_TIME__,'Z'
   105                              <2> 		asciz		; for future extension
   106                              <2>  %endmacro
   107                              <2> %else
   108                              <2>  %define PUT_ELDHX_DATETIME_OFFSET
   109                              <2>  %define PUT_ELD_DATETIME
   110                              <2> %endif
   111                              <2> 
   112                              <2> %endif
    17                              <1> 
    18                              <1> 	cpu 8086
    19                              <1> 
    20                              <1> %if ELDSTRICT
    21                              <1>  %if ELDSTRICTCOUNTER
    22                              <1>   %error Missing relocation
    23                              <1>  %endif
    24                              <1> %endif
    25                              <1> 	eldstrict off		; linker does some relocations
    26                              <1> 
    27                              <1> %ifn ELDCALLCALL_DUMPED
    28                              <1> 	eldcall_dump_callcall ELDCALL_CALLCALL_LIST
    29                              <1> %endif
    30                              <1> 
    31                              <1> 	numdef ELD_IDENTICALISE, 0
    32                              <1> 	numdef ELD_DEBUG, 0
    33                              <1> 	numdef ELD_LINKER_PASSES, 1
    34                              <1> 	strdef LISTING, _ELD_LISTING
    35                              <1> 	numdef ELDCALL_OPTIONAL, ELDCALL_OPTIONAL_STATUS
    36                              <1> 	numdef ELDDATA_OPTIONAL, ELDDATA_OPTIONAL_STATUS
    37                              <1> %if _ELD_IDENTICALISE
    38                              <1>  ;%assign _ELDCALL_OPTIONAL 1
    39                              <1> %endif
    40                              <1> %ifn _ELDCALL_OPTIONAL
    41                              <1> %assign ELDCALL_OPTIONAL_STATUS 2		; not allowed
    42                              <1> %endif
    43                              <1> ;%ifn _ELDDATA_OPTIONAL
    44                              <1> ;%assign ELDDATA_OPTIONAL_STATUS 2		; not allowed
    45                              <1> ;%endif
    46                              <1> 
    47                              <1> 
    48                              <1> endresident: equ ($ + _CURRENT_SECTION %+ FIXUP + 15) & ~15
    49                              <1> 
    50                              <1> %if _ELD_LINKER_PASSES
    51                              <1> %assign ELDLINKER 1
    52                              <1> 
    53                              <1> 	struc LINKTABLE
    54 00000000 ????????            <1> ltCodeToCode:	resw 2
    55 00000004 ????????            <1> ltCodeToData:	resw 2
    56 00000008 ????????            <1> ltDataToCode:	resw 2
    57 0000000C ????????            <1> ltDataToData:	resw 2
    58 00000010 ????????            <1> ltLinkData:	resw 2
    59 00000014 ????????            <1> ltLinkCode:	resw 2
    60                              <1> 	endstruc
    61                              <1> %endif
    62                              <1> 
    63                              <1> 
    64                              <1> linker:
    65                              <1> 		; The first 15 Bytes of the linker should be
    66                              <1> 		;  the same regardless of the linker options
    67                              <1> 		;  used (debug, passes, vstart). This allows
    68                              <1> 		;  the eldcomp ELD to match even if up to 15
    69                              <1> 		;  Bytes of the linker are trailing in the
    70                              <1> 		;  resident part of the ELD.
    71                              <1> 	lframe
    72                              <1>  %if ELDOTHER
    73                              <1> 	lvar dword, linkinfo_other
    74                              <1> 	lvar word, use_hash_other
    75                              <1>  %endif
    76 00000290 5589E5              <1> 	lenter
    77                              <1> 	lvar dword, instance
    78 00000293 06                  <1> 	 push es
    79 00000294 52                  <1> 	 push dx
    80                              <1> 	lvar word, targetsection_low_optional_high
    81 00000295 50                  <1> 	 push ax
    82                              <1> 	lequ ?targetsection_low_optional_high, targetsection
    83                              <1> 	lequ ?targetsection_low_optional_high + 1, optional
    84                              <1> 	lvar dword, linkinfo
    85 00000296 1E                  <1> 	 push ds
    86 00000297 57                  <1> 	 push di
    87                              <1> 	lvar dword, nextreloc
    88 00000298 06                  <1> 	 push es
    89 00000299 52                  <1> 	 push dx
    90                              <1> 	lvar dword, entry
    91 0000029A 06                  <1> 	 push es
    92 0000029B 50                  <1> 	 push ax		; placeholder
    93 0000029C 31C0                <1> 	xor ax, ax
    94 0000029E 813DD1E1            <1> 	cmp word [di + eldlSignature], 0E1D1h
    95                              <1> %if ($ - linker) < 16
    96                              <1>  %error Expected invariant first paragraph of linker
    97                              <1> %endif
    98 000002A2 7403E95502          <1> 	jne .error_j
    99 000002A7 837D0601            <1> 	cmp word [di + eldlUseLinkHash], 1
   100 000002AB 7603E94C02          <1> 	ja .error_j
   101 000002B0 7201                <1> 	jb @F
   102 000002B2 48                  <1> 	dec ax
   103                              <1> @@:
   104                              <1> 	lvar word, use_hash
   105 000002B3 50                  <1> 	 push ax
   106                              <1> %if _ELD_IDENTICALISE && _ELD_LINKER_PASSES
   107                              <1> 	mov ax, linktable - code
   108                              <1> 	lvar word, lt
   109                              <1> 	 push ax
   110                              <1> %endif
   111                              <1> %if _ELD_LINKER_PASSES || ELDOTHER
   112 000002B4 31C0                <1> 	xor ax, ax
   113                              <1>  %if _ELD_LINKER_PASSES
   114                              <1> 	lvar word, pass
   115 000002B6 50                  <1> 	 push ax
   116                              <1> 	lvar word, amounterrors
   117 000002B7 50                  <1> 	 push ax
   118                              <1> 	lvar word, name
   119 000002B8 50                  <1> 	 push ax
   120                              <1>  %endif
   121                              <1>  %if ELDOTHER
   122                              <1> 	lvar word, other
   123                              <1> 	 push ax
   124                              <1>  %endif
   125                              <1> %endif
   126 000002B9 56                  <1> 	push si
   127 000002BA 53                  <1> 	push bx
   128                              <1> 
   129                              <1> 			; simple: add instance base (dx) to code
   130 000002BB 06                  <1> 	push es
   131 000002BC 1F                  <1> 	pop ds
   132                              <1> %if _ELD_LINKER_PASSES
   133                              <1> .pass:
   134 000002BD 8B5EEA              <1> 	mov bx, word [bp + ?pass]
   135 000002C0 01D3                <1> 	add bx, dx
   136                              <1>  %if _ELD_IDENTICALISE
   137                              <1> 	add bx, word [bp + ?lt]
   138                              <1> 	mov si, word [ltCodeToCode + bx]
   139                              <1>  %else
   140 000002C2 8BB71C06            <1> 	mov si, word [linktable - code + ltCodeToCode + bx]
   141                              <1>  %endif
   142                              <1> %else
   143                              <1> 	mov si, internalcodetocoderelocations - code
   144                              <1> %endif
   145 000002C6 01D6                <1> 	add si, dx
   146                              <1> @@:
   147 000002C8 AD                  <1> 	lodsw
   148 000002C9 85C0                <1> 	test ax, ax		; was last ?
   149 000002CB 740B                <1> 	jz @F			; yes -->
   150 000002CD 93                  <1> 	xchg bx, ax		; bx = entry
   151 000002CE 01D3                <1> 	add bx, dx		; relocate the entry itself
   152                              <1> %if _ELD_CODE_VSTART
   153 000002D0 812F[0000]          <1> 	sub word [bx], code	; undo adjustment
   154                              <1> %endif
   155 000002D4 0117                <1> 	add word [bx], dx	; relocate word referenced by entry
   156 000002D6 EBF0                <1> 	jmp @B
   157                              <1> 
   158                              <1> @@:
   159                              <1> 			; next, add heap data base (on stack) to code
   160                              <1> %if _ELD_LINKER_PASSES
   161 000002D8 8B5EEA              <1> 	mov bx, word [bp + ?pass]
   162 000002DB 01D3                <1> 	add bx, dx
   163                              <1>  %if _ELD_IDENTICALISE
   164                              <1> 	add bx, word [bp + ?lt]
   165                              <1> 	mov si, word [ltCodeToData + bx]
   166                              <1>  %else
   167 000002DD 8BB72006            <1> 	mov si, word [linktable - code + ltCodeToData + bx]
   168                              <1>  %endif
   169                              <1> %else
   170                              <1> 	mov si, internalcodetodatarelocations - code
   171                              <1> %endif
   172 000002E1 01D6                <1> 	add si, dx
   173                              <1> @@:
   174 000002E3 AD                  <1> 	lodsw
   175 000002E4 85C0                <1> 	test ax, ax		; was last ?
   176 000002E6 740C                <1> 	jz @F			; yes -->
   177 000002E8 93                  <1> 	xchg bx, ax		; bx = entry
   178 000002E9 01D3                <1> 	add bx, dx		; relocate the entry itself
   179 000002EB 58                  <1> 	pop ax			; ax -> heap data
   180 000002EC 50                  <1> 	push ax
   181                              <1> %if _ELD_DATA_VSTART
   182 000002ED 2D[0000]            <1> 	sub ax, datastart	; undo adjustment
   183                              <1> %endif
   184 000002F0 0107                <1> 	add word [bx], ax	; relocate word referenced by entry
   185 000002F2 EBEF                <1> 	jmp @B
   186                              <1> 
   187                              <1> @@:
   188                              <1> 
   189                              <1> 			; add instance base (dx) to data
   190                              <1> %if _ELD_LINKER_PASSES
   191 000002F4 8B5EEA              <1> 	mov bx, word [bp + ?pass]
   192 000002F7 01D3                <1> 	add bx, dx
   193                              <1>  %if _ELD_IDENTICALISE
   194                              <1> 	add bx, word [bp + ?lt]
   195                              <1> 	mov si, word [ltDataToCode + bx]
   196                              <1>  %else
   197 000002F9 8BB72406            <1> 	mov si, word [linktable - code + ltDataToCode + bx]
   198                              <1>  %endif
   199                              <1> %else
   200                              <1> 	mov si, internaldatatocoderelocations - code
   201                              <1> %endif
   202 000002FD 01D6                <1> 	add si, dx
   203                              <1> @@:
   204 000002FF AD                  <1> 	lodsw
   205 00000300 83F8FF              <1> 	cmp ax, -1		; was last ?
   206 00000303 740F                <1> 	je @F			; yes -->
   207 00000305 93                  <1> 	xchg bx, ax		; bx = entry
   208 00000306 58                  <1> 	pop ax
   209 00000307 50                  <1> 	push ax
   210 00000308 01C3                <1> 	add bx, ax		; relocate the entry itself
   211                              <1> %if _ELD_CODE_VSTART
   212 0000030A 36812F[0000]        <1> 	sub word [ss:bx], code	; undo adjustment
   213                              <1> %endif
   214 0000030F 360117              <1> 	add word [ss:bx], dx	; relocate word referenced by entry
   215 00000312 EBEB                <1> 	jmp @B
   216                              <1> 
   217                              <1> @@:
   218                              <1> 			; next, add heap data base (on stack) to data
   219                              <1> %if _ELD_LINKER_PASSES
   220 00000314 8B5EEA              <1> 	mov bx, word [bp + ?pass]
   221 00000317 01D3                <1> 	add bx, dx
   222                              <1>  %if _ELD_IDENTICALISE
   223                              <1> 	add bx, word [bp + ?lt]
   224                              <1> 	mov si, word [ltDataToData + bx]
   225                              <1>  %else
   226 00000319 8BB72806            <1> 	mov si, word [linktable - code + ltDataToData + bx]
   227                              <1>  %endif
   228                              <1> %else
   229                              <1> 	mov si, internaldatatodatarelocations - code
   230                              <1> %endif
   231 0000031D 01D6                <1> 	add si, dx
   232                              <1> @@:
   233 0000031F AD                  <1> 	lodsw
   234 00000320 83F8FF              <1> 	cmp ax, -1		; was last ?
   235 00000323 740D                <1> 	je @F			; yes -->
   236 00000325 93                  <1> 	xchg bx, ax		; bx = entry
   237 00000326 58                  <1> 	pop ax			; ax -> heap data
   238 00000327 50                  <1> 	push ax
   239 00000328 01C3                <1> 	add bx, ax		; relocate the entry itself
   240                              <1> %if _ELD_DATA_VSTART
   241 0000032A 2D[0000]            <1> 	sub ax, datastart	; undo adjustment
   242                              <1> %endif
   243 0000032D 360107              <1> 	add word [ss:bx], ax	; relocate word referenced by entry
   244 00000330 EBED                <1> 	jmp @B
   245                              <1> 
   246                              <1> @@:
   247 00000332 8B56FC              <1> 	mov dx, word [bp + ?instance]
   248                              <1> %if _ELD_LINKER_PASSES
   249 00000335 8B5EEA              <1> 	mov bx, word [bp + ?pass]
   250 00000338 01D3                <1> 	add bx, dx
   251                              <1>  %if _ELD_IDENTICALISE
   252                              <1> 	add bx, word [bp + ?lt]
   253                              <1> 	add dx, word [ltLinkData + bx]
   254                              <1>  %else
   255 0000033A 03972C06            <1> 	add dx, word [linktable - code + ltLinkData + bx]
   256                              <1>  %endif
   257                              <1> %else
   258                              <1> 	add dx, linkerdatarelocations - code
   259                              <1> %endif
   260                              <1> .otherloop:
   261 0000033E 8956F2              <1> 	mov word [bp + ?nextreloc], dx
   262                              <1> 
   263                              <1> .datarelocloop:		; must be done before further relocs
   264 00000341 C576F2              <1> 	lds si, [bp + ?nextreloc]
   265 00000344 AD                  <1> 	lodsw			; ax = section indicator
   266 00000345 85C0                <1> 	test ax, ax		; end of table ?
   267 00000347 7503E92301          <1> 	jz .donedatareloc
   268 0000034C 48                  <1> 	dec ax			; al = 1 if data, 0 if code
   269 0000034D 5B                  <1> 	pop bx
   270 0000034E 53                  <1> 	push bx			; bx -> ELD data block
   271 0000034F 8946FA              <1> 	mov word [bp + ?targetsection_low_optional_high], ax
   272 00000352 84C0                <1> 	test al, al		; data ?
   273 00000354 AD                  <1> 	lodsw
   274 00000355 7504                <1> 	jnz @F			; yes -->
   275 00000357 0346FC              <1> 	add ax, word [bp + ?instance]
   276                              <1> 				; relocate entry into code
   277 0000035A A9                  <1> 	db __TEST_IMM16		; (skip add)
   278                              <1> @@:
   279 0000035B 01D8                <1> 	add ax, bx		; relocate entry into data
   280 0000035D 8946EE              <1> 	mov word [bp + ?entry], ax
   281 00000360 AD                  <1> 	lodsw
   282 00000361 8976F2              <1> 	mov word [bp + ?nextreloc], si
   283 00000364 E8DC00              <1> 	call .build_match
   284                              <1> %if _ELD_LINKER_PASSES
   285 00000367 73D8                <1> 	jnc .datarelocloop
   286                              <1> %endif
   287 00000369 C45EF6              <1> 	les bx, [bp + ?linkinfo]
   288                              <1> %if ELDOTHER
   289                              <1> 	rol byte [bp + ?other], 1
   290                              <1> 	jnc @F
   291                              <1> 	les bx, [bp + ?linkinfo_other]
   292                              <1> @@:
   293                              <1> %endif
   294 0000036C 268B4F08            <1> 	mov cx, word [es:bx + eldlDataAmount]	; amount data link info
   295 00000370 268B7F0A            <1> 	mov di, word [es:bx + eldlDataPrefixes]	; -> prefixes or hashes
   296                              <1> .datarelocfind:
   297 00000374 F2AF                <1> 	repne scasw			; scan initial
   298 00000376 7541                <1> 	jne .datarelocnotfound
   299 00000378 57                  <1> 	push di
   300 00000379 51                  <1> 	push cx
   301 0000037A 56                  <1> 	push si
   302 0000037B 262B7F0A            <1> 	sub di, word [es:bx + eldlDataPrefixes]	; = double index, 1-based
   303 0000037F 4F                  <1> 	dec di
   304 00000380 4F                  <1> 	dec di				; 0-based
   305 00000381 26037F0C            <1> 	add di, word [es:bx + eldlDataEntries]	; -> entry
   306 00000385 268B3D              <1> 	mov di, [es:di]			; -> counted suffix/string
   307 00000388 B500                <1> 	mov ch, 0
   308 0000038A 8A0C                <1> 	mov cl, byte [si]		; cx = length
   309 0000038C 41                  <1> 	inc cx
   310                              <1> 	; cmp al, al			; ZR if length is zero
   311 0000038D F3A6                <1> 	repe cmpsb			; match ?
   312 0000038F 5E                  <1> 	pop si
   313 00000390 59                  <1> 	pop cx
   314 00000391 5F                  <1> 	pop di
   315 00000392 75E0                <1> 	jne .datarelocfind
   316 00000394 8814                <1> 	mov byte [si], dl
   317 00000396 262B7F0A            <1> 	sub di, word [es:bx + eldlDataPrefixes]	; = double index, 1-based
   318 0000039A 4F                  <1> 	dec di
   319 0000039B 4F                  <1> 	dec di				; 0-based
   320 0000039C 26037F0E            <1> 	add di, word [es:bx + eldlDataAddresses]	; -> address (offset)
   321 000003A0 268B05              <1> 	mov ax, word [es:di]
   322 000003A3 E80700              <1> 	call .address_data_reloc
   323                              <1> %if _ELD_RELOC_VSTART
   324 000003A6 2D[0000]            <1> 	sub ax, relocateddata		; *not* a relocation
   325                              <1> %endif
   326 000003A9 0104                <1> 	add word [si], ax		; relocate
   327 000003AB EB94                <1> 	jmp .datarelocloop
   328                              <1> 
   329                              <1> .address_data_reloc:
   330 000003AD C576EE              <1> 	lds si, [bp + ?entry]		; -> entry if in ELD code instance
   331 000003B0 807EFA00            <1> 	cmp byte [bp + ?targetsection], 0
   332                              <1> 					; relocation in code ?
   333 000003B4 7402                <1> 	je @F				; yes -->
   334 000003B6 16                  <1> 	push ss
   335 000003B7 1F                  <1> 	pop ds				; => our ELD data block
   336                              <1> @@:
   337 000003B8 C3                  <1> 	retn
   338                              <1> 
   339                              <1> .datarelocnotfound:
   340 000003B9 8814                <1> 	mov byte [si], dl
   341 000003BB 807EFB00            <1> 	cmp byte [bp + ?optional], 0
   342                              <1> %if _ELD_DEBUG
   343                              <1> 	jne @F
   344                              <1>  %ifn _ELD_LINKER_PASSES
   345                              <1> 	mov si, 0			; (invalid link)
   346                              <1> linkdatarelocation internalflags6
   347                              <1> 	test si, si
   348                              <1> 	jz .datanotfound
   349                              <1> 	mov si, 0			; (invalid link)
   350                              <1> linkdatarelocation options7
   351                              <1> 	test si, si
   352                              <1> 	jz .datanotfound
   353                              <1>  %else
   354                              <1> 	cmp byte [bp + ?pass], 0
   355                              <1> 	je .datanotfound
   356                              <1>  %endif
   357                              <1> 	houdini
   358                              <1> 	jmp .datanotfound
   359                              <1> @@:
   360                              <1> %else
   361 000003BF 7417                <1> 	je .datanotfound
   362                              <1> %endif
   363                              <1> 
   364                              <1> %if ELDDATA_PMREQUIRED_STATUS
   365                              <1> 	mov si, relocateddata
   366                              <1> linkdatarelocation build_option_PM
   367                              <1> 	test si, si
   368                              <1> 	jz @F
   369                              <1> 	test byte [bp + ?optional], 2
   370                              <1> 	jnz .datanotfound
   371                              <1> @@:
   372                              <1> %endif
   373                              <1> 
   374                              <1> %if _ELD_LINKER_PASSES
   375 000003C1 36F606[0000]02      <1> 	testopt [ss:relocateddata], 2
   376                              <1> linkdatarelocation options7, -3
   377 000003C7 7406                <1> 	jz @F
   378 000003C9 BE[6209]            <1> 	mov si, lmsg.warning_data_optional
   379                              <1> internalcoderelocation
   380 000003CC E82B00              <1> 	call .notfound
   381                              <1> @@:
   382                              <1> %endif
   383 000003CF E8DBFF              <1> 	call .address_data_reloc
   384 000003D2 832400              <1> 	and word [si], 0		; indicate optional data link failed
   385 000003D5 E969FF              <1> 	jmp .datarelocloop
   386                              <1> 
   387                              <1> 
   388                              <1> %if _ELDCALL_OPTIONAL
   389                              <1> .coderelocnotfound:
   390                              <1> 	mov byte [si], dl
   391                              <1> 	cmp byte [bp + ?optional], 0
   392                              <1> %if _ELD_DEBUG
   393                              <1> 	jne @F
   394                              <1>  %ifn _ELD_LINKER_PASSES
   395                              <1> 	mov si, 0			; (invalid link)
   396                              <1> linkdatarelocation internalflags6
   397                              <1> 	test si, si
   398                              <1> 	jz .codenotfound
   399                              <1> 	mov si, 0			; (invalid link)
   400                              <1> linkdatarelocation options7
   401                              <1> 	test si, si
   402                              <1> 	jz .codenotfound
   403                              <1>  %else
   404                              <1> 	cmp byte [bp + ?pass], 0
   405                              <1> 	je .codenotfound
   406                              <1>  %endif
   407                              <1> 	houdini
   408                              <1> 	jmp .codenotfound
   409                              <1> @@:
   410                              <1> %else
   411                              <1> 	je .codenotfound
   412                              <1> %endif
   413                              <1> 
   414                              <1> %if ELDCALL_PMREQUIRED_STATUS
   415                              <1>  %if _ELD_LINKER_PASSES
   416                              <1>   %assign ELDLINKER 0
   417                              <1>  %endif
   418                              <1> 	mov si, relocateddata
   419                              <1> linkdatarelocation build_option_PM
   420                              <1>  %if _ELD_LINKER_PASSES
   421                              <1>   %assign ELDLINKER 1
   422                              <1>  %endif
   423                              <1> 	test si, si
   424                              <1> 	jz @F
   425                              <1> 	test byte [bp + ?optional], 2
   426                              <1> 	jnz .codenotfound
   427                              <1> @@:
   428                              <1> %endif
   429                              <1> 
   430                              <1> %if _ELD_LINKER_PASSES
   431                              <1> 	testopt [ss:relocateddata], 2
   432                              <1> linkdatarelocation options7, -3
   433                              <1> 	jz @F
   434                              <1> 	mov si, lmsg.warning_code_optional
   435                              <1> internalcoderelocation
   436                              <1> 	call .notfound
   437                              <1> @@:
   438                              <1> %endif
   439                              <1> 	lds si, [bp + ?entry]
   440                              <1> 	mov word [si], 9090h
   441                              <1> 	mov byte [si + 2], 90h		; indicate optional code link failed
   442                              <1> 	jmp .coderelocloop
   443                              <1> %endif
   444                              <1> 
   445                              <1> 
   446                              <1> %if _ELD_LINKER_PASSES
   447                              <1> .datanotfound:
   448 000003D8 BE[8409]            <1> 	mov si, lmsg.error_data
   449                              <1> internalcoderelocation
   450 000003DB E81C00              <1> 	call .notfound
   451 000003DE 7203E91901          <1> 	jnc .error_j
   452 000003E3 FF46E8              <1> 	inc word [bp + ?amounterrors]
   453 000003E6 E958FF              <1> 	jmp .datarelocloop
   454                              <1> 
   455                              <1> .codenotfound:
   456 000003E9 BE[9D09]            <1> 	mov si, lmsg.error_code
   457                              <1> internalcoderelocation
   458 000003EC E80B00              <1> 	call .notfound
   459 000003EF 7203E90801          <1> 	jnc .error_j
   460 000003F4 FF46E8              <1> 	inc word [bp + ?amounterrors]
   461 000003F7 E98400              <1> 	jmp .coderelocloop
   462                              <1> 
   463                              <1> .notfound:
   464 000003FA 807EEA00            <1> 	cmp byte [bp + ?pass], 0
   465 000003FE 743A                <1> 	je @F				; --> (NC)
   466 00000400 16                  <1> 	 push ss
   467 00000401 07                  <1> 	 pop es
   468 00000402 BF[0000]            <1> 	mov di, relocateddata
   469                              <1> linkdatarelocation line_out
   470 00000405 E83300              <1> 	call .copy
   471 00000408 8B76E6              <1> 	mov si, word [bp + ?name]
   472 0000040B AD                  <1> 	lodsw
   473 0000040C E8[0000]EB020000    <1> 	extcall hexword
   474 00000413 56                  <1> 	push si
   475 00000414 BE[B609]            <1> 	mov si, lmsg.error.2
   476                              <1> internalcoderelocation
   477 00000417 E82100              <1> 	call .copy
   478 0000041A 5E                  <1> 	pop si
   479                              <1> %if _ELD_LINKER_PASSES
   480 0000041B 56                  <1> 	push si
   481 0000041C E81C00              <1> 	call .copy
   482 0000041F 5E                  <1> 	pop si
   483 00000420 C60400              <1> 	mov byte [si], 0		; mark as failed
   484                              <1> %else
   485                              <1> 	call .copy
   486                              <1> %endif
   487 00000423 B022                <1> 	mov al, '"'
   488 00000425 AA                  <1> 	stosb
   489 00000426 16                  <1> 	 push ss
   490 00000427 1F                  <1> 	 pop ds
   491 00000428 E8[0000]EB020000    <1> 	extcall putsline_crlf
   492 0000042F B8350E              <1> 	mov ax, 0E35h
   493 00000432 E8[0000]EB020000    <1> 	extcall setrc
   494 00000439 F9                  <1> 	stc				; CY, diagnostic displayed
   495                              <1> @@:
   496 0000043A C3                  <1> 	retn
   497                              <1> 
   498                              <1> .copy:
   499 0000043B E8[0000]EB020000    <1> 	extcall copy_single_counted_string
   500 00000442 C3                  <1> 	retn
   501                              <1> %else
   502                              <1> .datanotfound: equ .error_j
   503                              <1> .codenotfound: equ .error_j
   504                              <1> %endif
   505                              <1> 
   506                              <1> .build_match:
   507                              <1> %if _ELD_CODE_VSTART
   508 00000443 2D[0000]            <1> 	sub ax, code
   509                              <1> %endif
   510 00000446 0346FC              <1> 	add ax, word [bp + ?instance]
   511 00000449 96                  <1> 	xchg si, ax
   512                              <1> %if _ELD_LINKER_PASSES
   513 0000044A 8976E6              <1> 	mov word [bp + ?name], si
   514                              <1> %endif
   515 0000044D AD                  <1> 	lodsw			; = hash, si -> counted string
   516 0000044E 8A14                <1> 	mov dl, byte [si]
   517                              <1> %if _ELD_LINKER_PASSES
   518 00000450 84D2                <1> 	test dl, dl		; marked as already failed ?
   519 00000452 750A                <1> 	jnz @F
   520 00000454 837EE800            <1> 	cmp word [bp + ?amounterrors], 0
   521 00000458 7503E99F00          <1> 	je .error_j
   522 0000045D C3                  <1> 	retn			; (NC)
   523                              <1> 
   524                              <1> @@:
   525                              <1> %endif
   526                              <1> %if ELDOTHER
   527                              <1> 	rol byte [bp + ?other], 1
   528                              <1> 	jnc @F
   529                              <1> 	rol byte [bp + ?use_hash_other], 1
   530                              <1> 	jmp @FF
   531                              <1> 
   532                              <1> @@:
   533                              <1> %endif
   534 0000045E D046EC              <1> 	rol byte [bp + ?use_hash], 1
   535                              <1> @@:
   536 00000461 720A                <1> 	jc @F
   537 00000463 AC                  <1> 	lodsb
   538 00000464 91                  <1> 	xchg cx, ax		; cl = length
   539 00000465 AD                  <1> 	lodsw			; ax = prefix
   540 00000466 49                  <1> 	dec cx
   541 00000467 49                  <1> 	dec cx
   542 00000468 4E                  <1> 	dec si
   543 00000469 8A14                <1> 	mov dl, byte [si]
   544 0000046B 880C                <1> 	mov byte [si], cl	; si -> counted string suffix
   545                              <1> @@:
   546                              <1> %if _ELD_LINKER_PASSES
   547 0000046D F9                  <1> 	stc			; CY
   548                              <1> %endif
   549 0000046E C3                  <1> 	retn
   550                              <1> 
   551                              <1> 
   552                              <1> .donedatareloc:
   553                              <1> %if ELDOTHER
   554                              <1> 	rol byte [bp + ?other], 1
   555                              <1> 	jc .otherdone
   556                              <1> %endif
   557                              <1> 
   558 0000046F 8B56FC              <1> 	mov dx, word [bp + ?instance]
   559                              <1> %if _ELD_LINKER_PASSES
   560 00000472 8B5EEA              <1> 	mov bx, word [bp + ?pass]
   561 00000475 01D3                <1> 	add bx, dx
   562                              <1>  %if _ELD_IDENTICALISE
   563                              <1> 	add bx, word [bp + ?lt]
   564                              <1> 	add dx, word [ltLinkCode + bx]
   565                              <1>  %else
   566 00000477 03973006            <1> 	add dx, word [linktable - code + ltLinkCode + bx]
   567                              <1>  %endif
   568                              <1> %else
   569                              <1> 	add dx, linkercoderelocations - code
   570                              <1> %endif
   571 0000047B 8956F2              <1> 	mov word [bp + ?nextreloc], dx
   572                              <1> 
   573                              <1> .coderelocloop:
   574 0000047E C576F2              <1> 	lds si, [bp + ?nextreloc]
   575 00000481 AD                  <1> 	lodsw
   576                              <1> %if _ELDCALL_OPTIONAL
   577                              <1> 	dec ax
   578                              <1> 	js .donecodereloc
   579                              <1> 	mov word [bp + ?targetsection_low_optional_high], ax
   580                              <1> 	lodsw
   581                              <1> %endif
   582 00000482 0346FC              <1> 	add ax, word [bp + ?instance]
   583 00000485 8946EE              <1> 	mov word [bp + ?entry], ax
   584 00000488 AD                  <1> 	lodsw
   585 00000489 8976F2              <1> 	mov word [bp + ?nextreloc], si
   586                              <1> %ifn _ELDCALL_OPTIONAL
   587 0000048C 85C0                <1> 	test ax, ax
   588 0000048E 747E                <1> 	jz .donecodereloc
   589                              <1> %endif
   590 00000490 E8B0FF              <1> 	call .build_match
   591                              <1> %if _ELD_LINKER_PASSES
   592 00000493 73E9                <1> 	jnc .coderelocloop
   593                              <1> %endif
   594 00000495 C45EF6              <1> 	les bx, [bp + ?linkinfo]
   595 00000498 268B4F10            <1> 	mov cx, word [es:bx + eldlCodeAmount]	; amount code link info
   596 0000049C 268B7F12            <1> 	mov di, word [es:bx + eldlCodePrefixes]	; -> prefixes or hashes
   597                              <1> .coderelocfind:
   598 000004A0 F2AF                <1> 	repne scasw			; scan initial
   599                              <1> %if _ELDCALL_OPTIONAL
   600                              <1> 	jne .coderelocnotfound
   601                              <1> %else
   602                              <1>  %if _ELD_DEBUG
   603                              <1> 	je @F
   604                              <1> 	houdini
   605                              <1> 	jmp .codenotfound
   606                              <1> @@:
   607                              <1>  %else
   608 000004A2 7403E942FF          <1> 	jne .codenotfound
   609                              <1>  %endif
   610                              <1> %endif
   611 000004A7 57                  <1> 	push di
   612 000004A8 51                  <1> 	push cx
   613 000004A9 56                  <1> 	push si
   614 000004AA 262B7F12            <1> 	sub di, word [es:bx + eldlCodePrefixes]	; = double index, 1-based
   615 000004AE 4F                  <1> 	dec di
   616 000004AF 4F                  <1> 	dec di				; 0-based
   617 000004B0 26037F14            <1> 	add di, word [es:bx + eldlCodeEntries]	; -> entry
   618 000004B4 268B3D              <1> 	mov di, [es:di]			; -> counted suffix/string
   619 000004B7 B500                <1> 	mov ch, 0
   620 000004B9 8A0C                <1> 	mov cl, byte [si]		; cx = length
   621 000004BB 41                  <1> 	inc cx
   622                              <1> 	; cmp al, al			; ZR if length is zero
   623 000004BC F3A6                <1> 	repe cmpsb			; match ?
   624 000004BE 5E                  <1> 	pop si
   625 000004BF 59                  <1> 	pop cx
   626 000004C0 5F                  <1> 	pop di
   627 000004C1 75DD                <1> 	jne .coderelocfind
   628 000004C3 8814                <1> 	mov byte [si], dl
   629 000004C5 262B7F12            <1> 	sub di, word [es:bx + eldlCodePrefixes]	; = double index, 1-based
   630 000004C9 4F                  <1> 	dec di
   631 000004CA 4F                  <1> 	dec di				; 0-based
   632 000004CB 01FF                <1> 	add di, di			; quadruple index
   633 000004CD 26037F16            <1> 	add di, word [es:bx + eldlCodeAddresses]	; -> address (offset, segment)
   634 000004D1 26FF35              <1> 	push word [es:di]
   635 000004D4 C576EE              <1> 	lds si, [bp + ?entry]
   636 000004D7 8F4405              <1> 	pop word [si + 3 + 2]		; call near imm (3), jmp short (2)
   637                              <1> 					;  patch the destination address
   638 000004DA 803CE8              <1> 	cmp byte [si], 0E8h		; is it as expected ?
   639 000004DD 751D                <1> 	jne .error_j
   640 000004DF 268B7D02            <1> 	mov di, word [es:di + 2]
   641 000004E3 BB[0000]            <1> 	mov bx, relocateddata
   642                              <1> linkdatarelocation linkcall_table	; ss:bx -> link call table
   643 000004E6 36833F01            <1> 	cmp word [ss:bx], 1		; is it initialised to format 1 ?
   644 000004EA 7510                <1> 	jne .error_j			; no -->
   645 000004EC 368B4F02            <1> 	mov cx, word [ss:bx + 2]	; get amount of segments
   646 000004F0 E30A                <1> 	jcxz .error_j			; none -->
   647                              <1> @@:
   648 000004F2 83C304              <1> 	add bx, 4			; -> next segment
   649 000004F5 36393F              <1> 	cmp word [ss:bx], di		; value matches ?
   650 000004F8 7405                <1> 	je @F				; yes, found -->
   651 000004FA E2F6                <1> 	loop @B				; try remaining segments
   652                              <1> .error_j:
   653 000004FC E98A00              <1> 	jmp .error
   654                              <1> 
   655                              <1> @@:
   656 000004FF 368B5F02            <1> 	mov bx, word [ss:bx + 2]	; -> call destination offset
   657                              <1> 		; si + 3 + delta = bx
   658                              <1> 		; delta = bx - si - 3
   659 00000503 29F3                <1> 	sub bx, si
   660 00000505 83EB03              <1> 	sub bx, 3
   661 00000508 895C01              <1> 	mov word [si + 1], bx		; patch the call instruction
   662 0000050B E970FF              <1> 	jmp .coderelocloop
   663                              <1> 
   664                              <1> .donecodereloc:
   665                              <1> %if _ELD_LINKER_PASSES
   666 0000050E 8B46E8              <1> 	mov ax, word [bp + ?amounterrors]
   667 00000511 85C0                <1> 	test ax, ax
   668 00000513 75E7                <1> 	jnz .error_j
   669 00000515 8B5EEA              <1> 	mov bx, word [bp + ?pass]
   670 00000518 85DB                <1> 	test bx, bx
   671 0000051A 750B                <1> 	jnz @F
   672 0000051C 43                  <1> 	inc bx
   673 0000051D 43                  <1> 	inc bx
   674 0000051E 895EEA              <1> 	mov word [bp + ?pass], bx
   675 00000521 8B56FC              <1> 	mov dx, word [bp + ?instance]
   676 00000524 E996FD              <1> 	jmp .pass
   677                              <1> 
   678                              <1> @@:
   679                              <1> %endif
   680                              <1> 
   681                              <1> %ifnidni _LISTING, ""
   682                              <1> %assign ELDLINKER 0
   683                              <1> .hint:
   684 00000527 16                  <1> 	push ss
   685 00000528 1F                  <1> 	pop ds
   686 00000529 B02D                <1> 	mov al, 2Dh
   687 0000052B E8[0000]EB020000    <1> 	extcall intchk			; ZR if offset = -1 or segment = 0
   688                              <1> 					; CHG: ax, dx, bx
   689 00000532 7437                <1> 	jz .no_hint
   690                              <1> 
   691 00000534 8A26[0000]          <1> 	mov ah, byte [relocateddata]
   692                              <1> linkdatarelocation try_debugger_amis_multiplex_number
   693 00000538 E85500              <1> 	call plex_check
   694 0000053B 7305                <1> 	jnc @F
   695                              <1> 
   696 0000053D B4FF                <1> 	mov ah, 0FFh		; start with multiplex number 0FFh
   697                              <1> .loop_hint:
   698 0000053F E84E00              <1> 	call plex_check
   699                              <1> @@:
   700 00000542 7307                <1> 	jnc .end_hint		; if found --> (NC)
   701 00000544 80EC01              <1> 	sub ah, 1		; search is backward (to find latest installed first), from 0FFh to 00h including
   702 00000547 73F6                <1> 	jnc .loop_hint		; try next if we didn't check all yet -->
   703 00000549 EB20                <1> 	jmp .no_hint
   704                              <1> 
   705                              <1> .end_hint:
   706 0000054B 50                  <1> 	push ax
   707 0000054C C446FC              <1> 	les ax, [bp + ?instance]
   708 0000054F BF[7507]            <1> 	mov di, listmsg.hint.offset
   709                              <1> internalcoderelocation
   710 00000552 E8[0000]EB020000    <1> 	extcall hexword
   711 00000559 BB[5407]            <1> 	mov bx, listmsg.hint
   712                              <1> internalcoderelocation
   713 0000055C 368B16[0000]        <1> 	mov dx, [ss:relocateddata]
   714                              <1> linkdatarelocation extseg	; must be 86 Mode segment even in PM
   715 00000561 58                  <1> 	pop ax
   716 00000562 B040                <1> 	mov al, 40h		; AMIS message display service
   717 00000564 E8[0000]EB020000    <1> 	extcall call_int2D
   718                              <1> .no_hint:
   719                              <1> %endif
   720                              <1> 
   721                              <1> %if ELDOTHER
   722                              <1> %assign ELDLINKER 0
   723                              <1> 	not byte [bp + ?other]
   724                              <1> 
   725                              <1> 	push ss
   726                              <1> 	pop ds
   727                              <1> 	mov al, 2Dh
   728                              <1> 	extcall intchk			; ZR if offset = -1 or segment = 0
   729                              <1> 					; CHG: ax, dx, bx
   730                              <1> 	jz .no_other
   731                              <1> 
   732                              <1> 	mov ah, byte [relocateddata]
   733                              <1> linkdatarelocation try_debugger_amis_multiplex_number
   734                              <1> 	call plex_check
   735                              <1> 	jnc @F
   736                              <1> 
   737                              <1> 	mov ah, 0FFh		; start with multiplex number 0FFh
   738                              <1> .loop_other:
   739                              <1> 	call plex_check
   740                              <1> @@:
   741                              <1> 	jnc .end_other		; if found --> (NC)
   742                              <1> 	sub ah, 1		; search is backward (to find latest installed first), from 0FFh to 00h including
   743                              <1> 	jnc .loop_other		; try next if we didn't check all yet -->
   744                              <1> 	jmp .no_other
   745                              <1> 
   746                              <1> .end_other:
   747                              <1> 	mov al, 42h		; AMIS get other link info service
   748                              <1> 	extcall call_int2D
   749                              <1> 	cmp al, 0FFh
   750                              <1> 	jne .no_other
   751                              <1> 
   752                              <1> 	mov ax, si		; selector => PSP
   753                              <1> 	extcall ispm
   754                              <1> 	jz @F
   755                              <1> 	mov ax, dx		; segment => PSP
   756                              <1> @@:
   757                              <1> 	 push ss
   758                              <1> 	 pop ds
   759                              <1> 	mov word [otherds], ax
   760                              <1> internaldatarelocation		; current mode sel/seg
   761                              <1> 	mov word [otherseg], dx
   762                              <1> internaldatarelocation		; remember segment
   763                              <1> 
   764                              <1> 	mov ax, cx		; selector => link info
   765                              <1> 	extcall ispm
   766                              <1> 	jz @F
   767                              <1> 	mov ax, bx		; segment => link info
   768                              <1> @@:
   769                              <1> 	mov word [bp + ?linkinfo_other], di
   770                              <1> 	mov word [bp + ?linkinfo_other + 2], ax
   771                              <1> 
   772                              <1> 	mov ds, ax		; => link info
   773                              <1> 	xor ax, ax
   774                              <1> 	cmp word [di + eldlSignature], 0E1D1h
   775                              <1> 	jne .error_other
   776                              <1> 	cmp word [di + eldlUseLinkHash], 1
   777                              <1> 	ja .error_other
   778                              <1> 	jb @F
   779                              <1> 	dec ax
   780                              <1> @@:
   781                              <1> 	mov word [bp + ?use_hash_other], ax
   782                              <1> 
   783                              <1> 	mov dx, word [bp + ?instance]
   784                              <1> 	add dx, linkerotherdatarelocations - code
   785                              <1> 	jmp .otherloop
   786                              <1> 
   787                              <1> .error_other:
   788                              <1> 	push cs
   789                              <1> 	pop ds
   790                              <1> 	mov ax, 0E33h
   791                              <1> 	extcall setrc
   792                              <1> 	mov dx, lmsg.error_other
   793                              <1> internalcoderelocation
   794                              <1> 	jmp @F
   795                              <1> 
   796                              <1> .no_other:
   797                              <1> 	push cs
   798                              <1> 	pop ds
   799                              <1> 	mov ax, 0E34h
   800                              <1> 	extcall setrc
   801                              <1> 	mov dx, lmsg.no_other
   802                              <1> internalcoderelocation
   803                              <1> @@:
   804                              <1> 	extcall putsz
   805                              <1> 	jmp .error
   806                              <1> 
   807                              <1> .otherdone:
   808                              <1> %endif
   809                              <1> 
   810 0000056B 5B                  <1> 	pop bx				; -> our heap data
   811 0000056C 5E                  <1> 	pop si				; -> our command line tail
   812 0000056D 16                  <1> 	 push ss
   813 0000056E 1F                  <1> 	 pop ds
   814 0000056F C47EFC              <1> 	les di, [bp + ?instance]
   815 00000572 268B4502            <1> 	mov ax, word [es:di + eldiEndCode]
   816                              <1> houdini
   817 00000576 2D[9002]            <1> 	sub ax, strict word endresident + code
   818                              <1> internalcoderelocation
   819 00000579 26C74502[9002]      <1> 	mov word [es:di + eldiEndCode], endresident + code
   820                              <1> internalcoderelocation
   821 0000057F 2906[0000]          <1> 	sub word [relocateddata], ax
   822                              <1> linkdatarelocation extseg_used
   823                              <1> %if _DATA_SIZE == 0
   824                              <1> 	xor ax, ax
   825                              <1> 	mov word [es:di + eldiStartData], ax
   826                              <1> 	mov word [es:di + eldiEndData], ax
   827                              <1> %endif
   828 00000583 89EC5D              <1> 	lleave code
   829                              <1> 		; INP:	es => ELD code segment
   830                              <1> 		;	ds:si -> command line tail
   831                              <1> 		;	ds:bx -> ELD data block
   832                              <1> 		;	ss:sp -> far return address for current mode
   833                              <1> 		; STT:	ds = ss, UP, EI
   834 00000586 E957FC              <1> 	jmp start
   835                              <1> 
   836                              <1> .error:
   837 00000589 89EC5D              <1> 	lleave
   838 0000058C B8FFFF              <1> 	mov ax, -1
   839 0000058F CB                  <1> 	retf
   840                              <1> 
   841                              <1> 
   842                              <1> %ifnidni _LISTING, ""
   843                              <1>  %assign ELDHINT 1
   844                              <1> %else
   845                              <1>  %assign ELDHINT 0
   846                              <1> %endif
   847                              <1> 
   848                              <1> %if ELDOTHER || ELDHINT
   849                              <1> 		; INP:	ah = multiplex number to check
   850                              <1> 		; OUT:	CY if multiplex number unused or no signature match,
   851                              <1> 		;	 bp, ah, ds unmodified
   852                              <1> 		;	NC if match found,
   853                              <1> 		;	 ah = multiplex number (unmodified)
   854                              <1> 		; CHG:	si, di, es, cx, dx
   855                              <1> plex_check:
   856 00000590 16                  <1> 	push ss
   857 00000591 1F                  <1> 	pop ds
   858 00000592 F606[0000]08        <1> 	testopt [relocateddata], 8
   859                              <1> linkdatarelocation internalflags4, -3
   860 00000597 740B                <1> 	jz @F
   861 00000599 BE[0000]            <1> 	mov si, relocateddata
   862                              <1> linkdatarelocation amis_multiplex_number, -2, optional
   863 0000059C 85F6                <1> 	test si, si
   864 0000059E 7404                <1> 	jz @F
   865 000005A0 3A24                <1> 	cmp ah, byte [si]
   866 000005A2 7420                <1> 	je .notfound		; do not use our own multiplexer -->
   867                              <1> @@:
   868 000005A4 B000                <1> 	mov al, 00h		; AMIS installation check
   869 000005A6 E8[0000]EB020000    <1> 	extcall call_int2D	; AMIS (or "DOS reserved" = iret if no AMIS present)
   870 000005AD 3CFF                <1> 	cmp al, 0FFh
   871 000005AF 7513                <1> 	jne .notfound
   872 000005B1 0E                  <1> 	push cs
   873 000005B2 1F                  <1> 	pop ds
   874 000005B3 BE[4407]            <1> 	mov si, debuggeramissig	; ds:si -> our AMIS name strings
   875                              <1> internalcoderelocation
   876 000005B6 E8[0000]EB020000    <1> 	extcall setes2dx	; es:di -> name strings of AMIS multiplexer that just answered
   877 000005BD B90800              <1> 	mov cx, 8		; Ignore description, only compare vendor and program name
   878 000005C0 F3A7                <1> 	repe cmpsw
   879 000005C2 7401                <1> 	je .checkret		; ZR, NC = match -->
   880                              <1> .notfound:
   881 000005C4 F9                  <1> 	stc			; CY no match
   882                              <1> .checkret:
   883 000005C5 C3                  <1> 	retn
   884                              <1> %endif
   885                              <1> 
   886                              <1> 
   887 000005C6 00<rep 2h>          <1> 	align 4, db 0
   888                              <1> linkercoderelocations:
   889                              <1> %if _ELDCALL_OPTIONAL
   890                              <1> 	dw ELDCALL_CODE_RELOCATIONS_OPTIONAL, 0
   891                              <1> %else
   892 000005C8 2200[7D07]A001-     <1> 	dw ELDCALL_CODE_RELOCATIONS, 0, 0
   892 000005CE [8C07]A801[9807]B0- <1>
   892 000005D5 01[A407]B801[AD07]- <1>
   892 000005DC C001[B407]C801-     <1>
   892 000005E2 [BB07]D001[C307]D8- <1>
   892 000005E9 01[CB07]3E02[A407]- <1>
   892 000005F0 2B05[0208]5205-     <1>
   892 000005F6 [DB07]6405[0B08]A6- <1>
   892 000005FD 05[0B08]B605[1808]- <1>
   892 00000604 00000000            <1>
   893                              <1> %endif
   894                              <1> 
   895                              <1> %if _ELD_LINKER_PASSES
   896                              <1> linkerlinkercoderelocations:
   897                              <1> %if _ELDCALL_OPTIONAL
   898                              <1> 	dw ELDCALL_LINKER_CODE_RELOCATIONS_OPTIONAL, 0
   899                              <1> %else
   900 00000608 0C04[DB07]2804-     <1> 	dw ELDCALL_LINKER_CODE_RELOCATIONS, 0, 0
   900 0000060E [CB07]3204[C307]3B- <1>
   900 00000615 04[E507]00000000    <1>
   901                              <1> %endif
   902                              <1> 
   903                              <1> 	align 2, db 0
   904                              <1> linktable:
   905                              <1> 	istruc LINKTABLE
   906                              <1> at ltCodeToCode
   907 0000061C 3407                <1> 	dw internallinkercodetocoderelocations - code
   908 0000061E D806                <1> 	dw internalcodetocoderelocations - code
   909                              <1> at ltCodeToData
   910 00000620 3E07                <1> 	dw internallinkercodetodatarelocations - code
   911 00000622 FA06                <1> 	dw internalcodetodatarelocations - code
   912                              <1> at ltDataToCode
   913 00000624 4007                <1> 	dw internallinkerdatatocoderelocations - code
   914 00000626 1C07                <1> 	dw internaldatatocoderelocations - code
   915                              <1> at ltDataToData
   916 00000628 4207                <1> 	dw internallinkerdatatodatarelocations - code
   917 0000062A 1E07                <1> 	dw internaldatatodatarelocations - code
   918                              <1> at ltLinkData
   919 0000062C 2007                <1> 	dw linkerlinkerdatarelocations - code
   920 0000062E 3406                <1> 	dw linkerdatarelocations - code
   921                              <1> at ltLinkCode
   922 00000630 0806                <1> 	dw linkerlinkercoderelocations - code
   923 00000632 C805                <1> 	dw linkercoderelocations - code
   924                              <1> 	iend
   925                              <1> %endif
   926                              <1> 
   927                              <1> 	align 2, db 0
   928                              <1> linkerdatarelocations:
   929 00000634 01004700[2308]0100- <1> 	dw LINK_DATA_RELOCATIONS, 0
   929 0000063C 4900[2D08]01004C00- <1>
   929 00000644 [3608]01007600-     <1>
   929 0000064A [4608]01007F00-     <1>
   929 00000650 [5108]01008B00-     <1>
   929 00000656 [5A08]0100AF00-     <1>
   929 0000065C [5A08]0101FE00-     <1>
   929 00000662 [7008]01013E01-     <1>
   929 00000668 [8008]01004801-     <1>
   929 0000066E [9008]01015601-     <1>
   929 00000674 [9B08]01017E01-     <1>
   929 0000067A [AE08]01018101-     <1>
   929 00000680 [BE08]0100E901-     <1>
   929 00000686 [CD08]01001D02-     <1>
   929 0000068C [DB08]01002D02-     <1>
   929 00000692 [E608]01003A02-     <1>
   929 00000698 [F408]01005102-     <1>
   929 0000069E [E608]01005D02-     <1>
   929 000006A4 [F408]01006102-     <1>
   929 000006AA [5A08]01007C02-     <1>
   929 000006B0 [5A08]01008202-     <1>
   929 000006B6 [DB08]01003605-     <1>
   929 000006BC [1409]01005F05-     <1>
   929 000006C2 [5108]01008105-     <1>
   929 000006C8 [E608]01009405-     <1>
   929 000006CE [3909]01019A05-     <1>
   929 000006D4 [4A09]0000          <1>
   930                              <1> 
   931                              <1> 	align 2, db 0
   932                              <1> internalcodetocoderelocations:
   933 000006D8 8600D3002402290231- <1> 	dw INTERNAL_CODE_TO_CODE_RELOCATIONS, 0
   933 000006E1 0236024D0259026402- <1>
   933 000006EA 77027E0250055A0577- <1>
   933 000006F3 057D05B4050000      <1>
   934                              <1> 
   935                              <1> 	align 2, db 0
   936                              <1> internalcodetodatarelocations:
   937 000006FA 340054005C00D700E8- <1> 	dw INTERNAL_CODE_TO_DATA_RELOCATIONS, 0
   937 00000703 00FA000B0120012601- <1>
   937 0000070C 390150019201F101F9- <1>
   937 00000715 01050288020000      <1>
   938                              <1> 
   939                              <1> 	align 2, db 0
   940                              <1> internaldatatocoderelocations:
   941 0000071C FFFF                <1> 	dw INTERNAL_DATA_TO_CODE_RELOCATIONS, -1
   942                              <1> 
   943                              <1> 	align 2, db 0
   944                              <1> internaldatatodatarelocations:
   945 0000071E FFFF                <1> 	dw INTERNAL_DATA_TO_DATA_RELOCATIONS, -1
   946                              <1> 
   947                              <1> %if _ELD_LINKER_PASSES
   948                              <1> 	align 2, db 0
   949                              <1> linkerlinkerdatarelocations:
   950 00000720 0100C403[DB08]0100- <1> 	dw LINK_LINKER_DATA_RELOCATIONS, 0
   950 00000728 0304[9008]0100E404- <1>
   950 00000730 [0309]0000          <1>
   951                              <1> 
   952                              <1> 	align 2, db 0
   953                              <1> internallinkercodetocoderelocations:
   954 00000734 CA03D903EA03150400- <1> 	dw INTERNAL_LINKER_CODE_TO_CODE_RELOCATIONS, 0
   954 0000073D 00                  <1>
   955                              <1> 
   956                              <1> 	align 2, db 0
   957                              <1> internallinkercodetodatarelocations:
   958 0000073E 0000                <1> 	dw INTERNAL_LINKER_CODE_TO_DATA_RELOCATIONS, 0
   959                              <1> 
   960                              <1> 	align 2, db 0
   961                              <1> internallinkerdatatocoderelocations:
   962 00000740 FFFF                <1> 	dw INTERNAL_LINKER_DATA_TO_CODE_RELOCATIONS, -1
   963                              <1> 
   964                              <1> 	align 2, db 0
   965                              <1> internallinkerdatatodatarelocations:
   966 00000742 FFFF                <1> 	dw INTERNAL_LINKER_DATA_TO_DATA_RELOCATIONS, -1
   967                              <1> %endif
   968                              <1> 
   969                              <1> %if ELDOTHER
   970                              <1> 	align 2, db 0
   971                              <1> linkerotherdatarelocations:
   972                              <1> 	dw LINK_OTHER_DATA_RELOCATIONS, 0
   973                              <1> 
   974                              <1>  %ifnidn LINK_OTHER_LINKER_DATA_RELOCATIONS, ""
   975                              <1>   %error Other linker data links not supported
   976                              <1>  %endif
   977                              <1> %endif
   978                              <1> 
   979                              <1> %if ELDOTHER || ELDHINT
   980                              <1> 	align 2, db 0
   981                              <1> debuggeramissig:
   982 00000744 65636D20<rep 5h>    <1> 		fill 8, 32, db "ecm"
   983 0000074C 6C446562756720-     <1> 		fill 8, 32, db "lDebug"
   983 0000074C <rep 2h>            <1>
   984                              <1> %endif
   985                              <1> 
   986                              <1> %ifnidni _LISTING, ""
   987                              <1> listmsg:
   988 00000754 547261634C6973742D- <1> .hint:		db "TracList-add-offset=",_LISTING,"::"
   988 0000075D 6164642D6F66667365- <1>
   988 00000766 743D686973746F7279- <1>
   988 0000076F 2E6C73743A3A        <1>
   989 00000775 2D2D2D2D680D0A00    <1> .hint.offset:	asciz "----h",13,10
   990                              <1> %endif
   991                              <1> 
   992 0000077D 30CD0C636D64335F6E- <1> 	eldcall_dump_names ELDCALL_CODE_NAMES
   992 00000786 6F745F657874D55509- <1>
   992 0000078F 736B6970636F6D6D61- <1>
   992 00000798 03C309697373747269- <1>
   992 000007A1 6E673FDDB90663686B- <1>
   992 000007AA 656F6CBABD04636D64- <1>
   992 000007B3 332890046973706D55- <1>
   992 000007BC 1205707574737AB212- <1>
   992 000007C5 0573657472636FA20D- <1>
   992 000007CE 707574736C696E655F- <1>
   992 000007D7 63726C668481076865- <1>
   992 000007E0 78776F7264D0BB1A63- <1>
   992 000007E9 6F70795F73696E676C- <1>
   992 000007F2 655F636F756E746564- <1>
   992 000007FB 5F737472696E679869- <1>
   992 00000804 06696E7463686B2130- <1>
   992 0000080D 0A63616C6C5F696E74- <1>
   992 00000816 3244B7740873657465- <1>
   992 0000081F 73326478            <1>
   993 00000823 C30B076C617374636D- <1> 	link_data_dump_names LINK_DATA_NAMES
   993 0000082C 646B5D06646D79636D- <1>
   993 00000835 6454400D6D73672E75- <1>
   993 0000083E 6E696E7374616C6CEB- <1>
   993 00000847 420865787464737365- <1>
   993 00000850 6CD52D066578747365- <1>
   993 00000859 6797B6136578745F63- <1>
   993 00000862 6F6D6D616E645F6861- <1>
   993 0000086B 6E646C65722AE70D68- <1>
   993 00000874 6973746F7279666F72- <1>
   993 0000087D 6D617473830D686973- <1>
   993 00000886 746F72796275666665- <1>
   993 0000088F 7284E3086C696E655F- <1>
   993 00000898 6F75747D4210686973- <1>
   993 000008A1 746F72792E7365676F- <1>
   993 000008AA 7273656C75AE0D6869- <1>
   993 000008B3 73746F72792E666972- <1>
   993 000008BC 737431AA0C68697374- <1>
   993 000008C5 6F72792E6C6173748D- <1>
   993 000008CE 710B6D73672E696E73- <1>
   993 000008D7 74616C6C5ABC086F70- <1>
   993 000008E0 74696F6E7337E7D30B- <1>
   993 000008E9 6578747365675F7573- <1>
   993 000008F2 6564B2400C65787464- <1>
   993 000008FB 6174615F7573656468- <1>
   993 00000904 440E6C696E6B63616C- <1>
   993 0000090D 6C5F7461626C65F09E- <1>
   993 00000916 227472795F64656275- <1>
   993 0000091F 676765725F616D6973- <1>
   993 00000928 5F6D756C7469706C65- <1>
   993 00000931 785F6E756D626572CB- <1>
   993 0000093A 510E696E7465726E61- <1>
   993 00000943 6C666C61677334688C- <1>
   993 0000094C 15616D69735F6D756C- <1>
   993 00000955 7469706C65785F6E75- <1>
   993 0000095E 6D626572            <1>
   994                              <1> %if ELDOTHER
   995                              <1> 	link_data_dump_names LINK_OTHER_DATA_NAMES
   996                              <1> %endif
   997                              <1> 
   998                              <1> lmsg:
   999                              <1> %if _ELD_LINKER_PASSES
  1000                              <1> %if _ELDCALL_OPTIONAL
  1001                              <1> .warning_code_optional:		counted "Optional code link missing, hash="
  1002                              <1> %endif
  1003 00000962 214F7074696F6E616C- <1> .warning_data_optional:		counted "Optional data link missing, hash="
  1003 0000096B 2064617461206C696E- <1>
  1003 00000974 6B206D697373696E67- <1>
  1003 0000097D 2C20686173683D      <1>
  1004 00000984 1844617461206C696E- <1> .error_data:			counted "Data link missing, hash="
  1004 0000098D 6B206D697373696E67- <1>
  1004 00000996 2C20686173683D      <1>
  1005 0000099D 18436F6465206C696E- <1> .error_code:			counted "Code link missing, hash="
  1005 000009A6 6B206D697373696E67- <1>
  1005 000009AF 2C20686173683D      <1>
  1006 000009B6 0A682C206C6162656C- <1> .error.2:			counted "h, label ",'"'
  1006 000009BF 2022                <1>
  1007                              <1> %endif
  1008                              <1> %if ELDOTHER
  1009                              <1> .no_other:		asciz "ELD linker: No other link info found!",13,10
  1010                              <1> .error_other:		asciz "ELD linker: Other link info unknown format!",13,10
  1011                              <1> %endif
  1012                              <1> 
  1013 000009C1 00<rep Fh>          <1> 	align 16, db 0
   502                                  
   503                                  	align 16
   504                                  code_size equ $ - code
